package IO::Socket::IP;BEGIN {$VERSION='0.39'}use strict;use warnings;use base qw(IO::Socket);use Carp;use Socket 1.97 qw(getaddrinfo getnameinfo sockaddr_family AF_INET AI_PASSIVE IPPROTO_TCP IPPROTO_UDP IPPROTO_IPV6 IPV6_V6ONLY NI_DGRAM NI_NUMERICHOST NI_NUMERICSERV NIx_NOHOST NIx_NOSERV SO_REUSEADDR SO_REUSEPORT SO_BROADCAST SO_ERROR SOCK_DGRAM SOCK_STREAM SOL_SOCKET);my$AF_INET6=eval {Socket::AF_INET6()};my$AI_ADDRCONFIG=eval {Socket::AI_ADDRCONFIG()}|| 0;use POSIX qw(dup2);use Errno qw(EINVAL EINPROGRESS EISCONN ENOTCONN ETIMEDOUT EWOULDBLOCK EOPNOTSUPP);use constant HAVE_MSWIN32=>($^O eq "MSWin32");use constant HAVE_GETPROTOBYNAME=>defined eval {getprotobyname("tcp")};my$IPv6_re=do {my$IPv4address=do {my$dec_octet=q<(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])>;qq<$dec_octet(?: \\. $dec_octet){3}>};my$IPv6address=do {my$h16=qq<[0-9A-Fa-f]{1,4}>;my$ls32=qq<(?: $h16 : $h16 | $IPv4address)>;qq<(?:
                                            (?: $h16 : ){6} $ls32
         |                               :: (?: $h16 : ){5} $ls32
         | (?:                   $h16 )? :: (?: $h16 : ){4} $ls32
         | (?: (?: $h16 : ){0,1} $h16 )? :: (?: $h16 : ){3} $ls32
         | (?: (?: $h16 : ){0,2} $h16 )? :: (?: $h16 : ){2} $ls32
         | (?: (?: $h16 : ){0,3} $h16 )? ::     $h16 :      $ls32
         | (?: (?: $h16 : ){0,4} $h16 )? ::                 $ls32
         | (?: (?: $h16 : ){0,5} $h16 )? ::                 $h16
         | (?: (?: $h16 : ){0,6} $h16 )? ::
      )>};qr<$IPv6address>xo};sub import {my$pkg=shift;my@symbols;for (@_){if($_ eq "-register"){IO::Socket::IP::_ForINET->register_domain(AF_INET);IO::Socket::IP::_ForINET6->register_domain($AF_INET6)if defined$AF_INET6}else {push@symbols,$_}}@_=($pkg,@symbols);goto&IO::Socket::import}{my$can_disable_v6only;sub CAN_DISABLE_V6ONLY {return$can_disable_v6only if defined$can_disable_v6only;socket my$testsock,Socket::PF_INET6(),SOCK_STREAM,0 or die "Cannot socket(PF_INET6) - $!";if(setsockopt$testsock,IPPROTO_IPV6,IPV6_V6ONLY,0){return$can_disable_v6only=1}elsif($!==EINVAL || $!==EOPNOTSUPP){return$can_disable_v6only=0}else {die "Cannot setsockopt() - $!"}}}sub new {my$class=shift;my%arg=(@_==1)? (PeerHost=>$_[0]): @_;return$class->SUPER::new(%arg)}sub configure {my$self=shift;my ($arg)=@_;$arg->{PeerHost}=delete$arg->{PeerAddr}if exists$arg->{PeerAddr}&&!exists$arg->{PeerHost};$arg->{PeerService}=delete$arg->{PeerPort}if exists$arg->{PeerPort}&&!exists$arg->{PeerService};$arg->{LocalHost}=delete$arg->{LocalAddr}if exists$arg->{LocalAddr}&&!exists$arg->{LocalHost};$arg->{LocalService}=delete$arg->{LocalPort}if exists$arg->{LocalPort}&&!exists$arg->{LocalService};for my$type (qw(Peer Local)){my$host=$type .'Host';my$service=$type .'Service';if(defined$arg->{$host}){($arg->{$host},my$s)=$self->split_addr($arg->{$host});$arg->{$service}=$s if defined$s}}$self->_io_socket_ip__configure($arg)}sub _io_socket_ip__configure {my$self=shift;my ($arg)=@_;my%hints;my@localinfos;my@peerinfos;my$listenqueue=$arg->{Listen};if(defined$listenqueue and (defined$arg->{PeerHost}|| defined$arg->{PeerService}|| defined$arg->{PeerAddrInfo})){croak "Cannot Listen with a peer address"}if(defined$arg->{GetAddrInfoFlags}){$hints{flags}=$arg->{GetAddrInfoFlags}}else {$hints{flags}=$AI_ADDRCONFIG}if(defined(my$family=$arg->{Family})){$hints{family}=$family}if(defined(my$type=$arg->{Type})){$hints{socktype}=$type}if(defined(my$proto=$arg->{Proto})){unless($proto =~ m/^\d+$/){my$protonum=HAVE_GETPROTOBYNAME ? getprotobyname($proto): eval {Socket->${\"IPPROTO_\U$proto"}()};defined$protonum or croak "Unrecognised protocol $proto";$proto=$protonum}$hints{protocol}=$proto}if(!defined$hints{socktype}and!defined$hints{protocol}){$hints{socktype}=SOCK_STREAM;$hints{protocol}=IPPROTO_TCP}if(!defined$hints{socktype}and defined$hints{protocol}){$hints{socktype}=SOCK_STREAM if$hints{protocol}==IPPROTO_TCP;$hints{socktype}=SOCK_DGRAM if$hints{protocol}==IPPROTO_UDP}if(my$info=$arg->{LocalAddrInfo}){ref$info eq "ARRAY" or croak "Expected 'LocalAddrInfo' to be an ARRAY ref";@localinfos=@$info}elsif(defined$arg->{LocalHost}or defined$arg->{LocalService}or HAVE_MSWIN32 and $arg->{Listen}){my$host=$arg->{LocalHost};my$service=$arg->{LocalService};unless (defined$host or defined$service){$service=0}local $1;defined$service and $service =~ s/\((\d+)\)$// and my$fallback_port=$1;my%localhints=%hints;$localhints{flags}|= AI_PASSIVE;(my$err,@localinfos)=getaddrinfo($host,$service,\%localhints);if($err and defined$fallback_port){($err,@localinfos)=getaddrinfo($host,$fallback_port,\%localhints)}if($err){$@="$err";$!=EINVAL;return}}if(my$info=$arg->{PeerAddrInfo}){ref$info eq "ARRAY" or croak "Expected 'PeerAddrInfo' to be an ARRAY ref";@peerinfos=@$info}elsif(defined$arg->{PeerHost}or defined$arg->{PeerService}){defined(my$host=$arg->{PeerHost})or croak "Expected 'PeerHost'";defined(my$service=$arg->{PeerService})or croak "Expected 'PeerService'";local $1;defined$service and $service =~ s/\((\d+)\)$// and my$fallback_port=$1;(my$err,@peerinfos)=getaddrinfo($host,$service,\%hints);if($err and defined$fallback_port){($err,@peerinfos)=getaddrinfo($host,$fallback_port,\%hints)}if($err){$@="$err";$!=EINVAL;return}}my$INT_1=pack "i",1;my@sockopts_enabled;push@sockopts_enabled,[SOL_SOCKET,SO_REUSEADDR,$INT_1 ]if$arg->{ReuseAddr};push@sockopts_enabled,[SOL_SOCKET,SO_REUSEPORT,$INT_1 ]if$arg->{ReusePort};push@sockopts_enabled,[SOL_SOCKET,SO_BROADCAST,$INT_1 ]if$arg->{Broadcast};if(my$sockopts=$arg->{Sockopts}){ref$sockopts eq "ARRAY" or croak "Expected 'Sockopts' to be an ARRAY ref";for (@$sockopts){ref $_ eq "ARRAY" or croak "Bad Sockopts item - expected ARRAYref";@$_ >= 2 and @$_ <= 3 or croak "Bad Sockopts item - expected 2 or 3 elements";my ($level,$optname,$value)=@$_;defined$value or $value=$INT_1;push@sockopts_enabled,[$level,$optname,$value ]}}my$blocking=$arg->{Blocking};defined$blocking or $blocking=1;my$v6only=$arg->{V6Only};if(defined$arg->{MultiHomed}and!$arg->{MultiHomed}){croak "Cannot disable the MultiHomed parameter"}my@infos;for my$local (@localinfos ? @localinfos : {}){for my$peer (@peerinfos ? @peerinfos : {}){next if defined$local->{family}and defined$peer->{family}and $local->{family}!=$peer->{family};next if defined$local->{socktype}and defined$peer->{socktype}and $local->{socktype}!=$peer->{socktype};next if defined$local->{protocol}and defined$peer->{protocol}and $local->{protocol}!=$peer->{protocol};my$family=$local->{family}|| $peer->{family}or next;my$socktype=$local->{socktype}|| $peer->{socktype}or next;my$protocol=$local->{protocol}|| $peer->{protocol}|| 0;push@infos,{family=>$family,socktype=>$socktype,protocol=>$protocol,localaddr=>$local->{addr},peeraddr=>$peer->{addr},}}}if(!@infos){if(defined$hints{family}){@infos=({family=>$hints{family},socktype=>$hints{socktype},protocol=>$hints{protocol},})}else {(my$err,@infos)=getaddrinfo("","0",\%hints);if($err){$@="$err";$!=EINVAL;return}}}${*$self}{io_socket_ip_infos}=\@infos;${*$self}{io_socket_ip_idx}=-1;${*$self}{io_socket_ip_sockopts}=\@sockopts_enabled;${*$self}{io_socket_ip_v6only}=$v6only;${*$self}{io_socket_ip_listenqueue}=$listenqueue;${*$self}{io_socket_ip_blocking}=$blocking;${*$self}{io_socket_ip_errors}=[undef,undef,undef ];$self->setup or!$blocking or return undef;return$self}sub setup {my$self=shift;while(1){${*$self}{io_socket_ip_idx}++;last if ${*$self}{io_socket_ip_idx}>= @{${*$self}{io_socket_ip_infos}};my$info=${*$self}{io_socket_ip_infos}->[${*$self}{io_socket_ip_idx}];$self->socket(@{$info}{qw(family socktype protocol)})or (${*$self}{io_socket_ip_errors}[2]=$!,next);$self->blocking(0)unless ${*$self}{io_socket_ip_blocking};for my$sockopt (@{${*$self}{io_socket_ip_sockopts}}){my ($level,$optname,$value)=@$sockopt;$self->setsockopt($level,$optname,$value)or ($@="$!",return undef)}if(defined ${*$self}{io_socket_ip_v6only}and defined$AF_INET6 and $info->{family}==$AF_INET6){my$v6only=${*$self}{io_socket_ip_v6only};$self->setsockopt(IPPROTO_IPV6,IPV6_V6ONLY,pack "i",$v6only)or ($@="$!",return undef)}if(defined(my$addr=$info->{localaddr})){$self->bind($addr)or (${*$self}{io_socket_ip_errors}[1]=$!,next)}if(defined(my$listenqueue=${*$self}{io_socket_ip_listenqueue})){$self->listen($listenqueue)or ($@="$!",return undef)}if(defined(my$addr=$info->{peeraddr})){if($self->connect($addr)){$!=0;return 1}if($!==EINPROGRESS or $!==EWOULDBLOCK){${*$self}{io_socket_ip_connect_in_progress}=1;return 0}return 0 if!$!;${*$self}{io_socket_ip_errors}[0]=$!;next}return 1}$!=(grep defined,@{${*$self}{io_socket_ip_errors}})[0];$@="$!";return undef}sub connect :method {my$self=shift;if(@_){my ($addr)=@_;my$timeout=${*$self}{'io_socket_timeout'};return connect($self,$addr)unless defined$timeout;my$was_blocking=$self->blocking(0);my$err=defined connect($self,$addr)? 0 : $!+0;if(!$err){$self->blocking($was_blocking);return 1}elsif(not($err==EINPROGRESS or $err==EWOULDBLOCK)){$self->blocking($was_blocking);return undef}elsif(!$was_blocking){return undef}my$vec='';vec($vec,$self->fileno,1)=1;if(!select(undef,$vec,$vec,$timeout)){$self->blocking($was_blocking);$!=ETIMEDOUT;return undef}$err=$self->getsockopt(SOL_SOCKET,SO_ERROR);$err=0 if$err==EISCONN;$self->blocking($was_blocking);$!=$err,return undef if$err;return 1}return 1 if!${*$self}{io_socket_ip_connect_in_progress};if(my$errno=$self->getsockopt(SOL_SOCKET,SO_ERROR)){delete ${*$self}{io_socket_ip_connect_in_progress};${*$self}{io_socket_ip_errors}[0]=$!=$errno;return$self->setup}my$addr=${*$self}{io_socket_ip_infos}[${*$self}{io_socket_ip_idx}]{peeraddr};if(connect($self,$addr)or $!==EISCONN){delete ${*$self}{io_socket_ip_connect_in_progress};$!=0;return 1}else {$!=EINPROGRESS;return 0}}sub connected {my$self=shift;return defined$self->fileno && !${*$self}{io_socket_ip_connect_in_progress}&& defined getpeername($self)}sub _get_host_service {my$self=shift;my ($addr,$flags,$xflags)=@_;defined$addr or $!=ENOTCONN,return;$flags |= NI_DGRAM if$self->socktype==SOCK_DGRAM;my ($err,$host,$service)=getnameinfo($addr,$flags,$xflags || 0);croak "getnameinfo - $err" if$err;return ($host,$service)}sub _unpack_sockaddr {my ($addr)=@_;my$family=sockaddr_family$addr;if($family==AF_INET){return (Socket::unpack_sockaddr_in($addr))[1]}elsif(defined$AF_INET6 and $family==$AF_INET6){return (Socket::unpack_sockaddr_in6($addr))[1]}else {croak "Unrecognised address family $family"}}sub sockhost_service {my$self=shift;my ($numeric)=@_;$self->_get_host_service($self->sockname,$numeric ? NI_NUMERICHOST|NI_NUMERICSERV : 0)}sub sockhost {my$self=shift;scalar +($self->_get_host_service($self->sockname,NI_NUMERICHOST,NIx_NOSERV))[0]}sub sockport {my$self=shift;scalar +($self->_get_host_service($self->sockname,NI_NUMERICSERV,NIx_NOHOST))[1]}sub sockhostname {my$self=shift;scalar +($self->_get_host_service($self->sockname,0,NIx_NOSERV))[0]}sub sockservice {my$self=shift;scalar +($self->_get_host_service($self->sockname,0,NIx_NOHOST))[1]}sub sockaddr {my$self=shift;_unpack_sockaddr$self->sockname}sub peerhost_service {my$self=shift;my ($numeric)=@_;$self->_get_host_service($self->peername,$numeric ? NI_NUMERICHOST|NI_NUMERICSERV : 0)}sub peerhost {my$self=shift;scalar +($self->_get_host_service($self->peername,NI_NUMERICHOST,NIx_NOSERV))[0]}sub peerport {my$self=shift;scalar +($self->_get_host_service($self->peername,NI_NUMERICSERV,NIx_NOHOST))[1]}sub peerhostname {my$self=shift;scalar +($self->_get_host_service($self->peername,0,NIx_NOSERV))[0]}sub peerservice {my$self=shift;scalar +($self->_get_host_service($self->peername,0,NIx_NOHOST))[1]}sub peeraddr {my$self=shift;_unpack_sockaddr$self->peername}sub accept {my$self=shift;my ($new,$peer)=$self->SUPER::accept(@_)or return;${*$new}{$_}=${*$self}{$_}for qw(io_socket_domain io_socket_type io_socket_proto);return wantarray ? ($new,$peer): $new}sub socket :method {my$self=shift;return$self->SUPER::socket(@_)if not defined$self->fileno;socket(my$tmph,$_[0],$_[1],$_[2])or return undef;dup2($tmph->fileno,$self->fileno)or die "Unable to dup2 $tmph onto $self - $!"}BEGIN {if(eval($IO::Socket::VERSION)< 1.35){*socktype=sub {my$self=shift;my$type=$self->SUPER::socktype;if(!defined$type){$type=$self->sockopt(Socket::SO_TYPE())}return$type}}}sub as_inet {my$self=shift;croak "Cannot downgrade a non-PF_INET socket to IO::Socket::INET" unless$self->sockdomain==AF_INET;return IO::Socket::INET->new_from_fd($self->fileno,"r+")}sub split_addr {shift;my ($addr)=@_;local ($1,$2);if($addr =~ m/\A\[($IPv6_re)\](?::([^\s:]*))?\z/ or $addr =~ m/\A([^\s:]*):([^\s:]*)\z/){return ($1,$2)if defined $2 and length $2;return ($1,undef)}return ($addr,undef)}sub join_addr {shift;my ($host,$port)=@_;$host="[$host]" if$host =~ m/:/;return join ":",$host,$port if defined$port;return$host}package IO::Socket::IP::_ForINET;use base qw(IO::Socket::IP);sub configure {my$self=shift;my ($arg)=@_;bless$self,"IO::Socket::IP";$self->configure({%$arg,Family=>Socket::AF_INET()})}package IO::Socket::IP::_ForINET6;use base qw(IO::Socket::IP);sub configure {my$self=shift;my ($arg)=@_;bless$self,"IO::Socket::IP";$self->configure({%$arg,Family=>Socket::AF_INET6()})}0x55AA;