package Pod::Parser;use strict;use vars qw($VERSION @ISA %myData %myOpts @input_stack);$VERSION='1.63';require 5.005;use Pod::InputObjects;use Carp;use Exporter;BEGIN {if ($] < 5.006){require Symbol;import Symbol}}@ISA=qw(Exporter);sub command {my ($self,$cmd,$text,$line_num,$pod_para)=@_;$self->textblock($pod_para->raw_text(),$line_num,$pod_para)}sub verbatim {my ($self,$text,$line_num,$pod_para)=@_;my$out_fh=$self->{_OUTPUT};print$out_fh $text}sub textblock {my ($self,$text,$line_num,$pod_para)=@_;my$out_fh=$self->{_OUTPUT};print$out_fh $self->interpolate($text,$line_num)}sub interior_sequence {my ($self,$seq_cmd,$seq_arg,$pod_seq)=@_;return$pod_seq->raw_text()}sub new {my ($this,%params)=@_;my$class=ref($this)|| $this;my$self={%params };bless$self,$class;$self->initialize();return$self}sub initialize {}sub begin_pod {}sub begin_input {}sub end_input {}sub end_pod {}sub preprocess_line {my ($self,$text,$line_num)=@_;return$text}sub preprocess_paragraph {my ($self,$text,$line_num)=@_;return$text}sub parse_text {my$self=shift;local $_='';my%opts=(ref $_[0])? %{shift()}: ();my$expand_seq=$opts{'-expand_seq'}|| undef;my$expand_text=$opts{'-expand_text'}|| undef;my$expand_ptree=$opts{'-expand_ptree'}|| undef;my$text=shift;my$line=shift;my$file=$self->input_file();my$cmd="";my$xseq_sub=$expand_seq;my$xtext_sub=$expand_text;my$xptree_sub=$expand_ptree;if (defined$expand_seq and $expand_seq eq 'interior_sequence'){$xseq_sub=sub {my ($sself,$iseq)=@_;my$args=join('',$iseq->parse_tree->children);return$sself->interior_sequence($iseq->name,$args,$iseq)}}ref$xseq_sub or $xseq_sub=sub {shift()->$expand_seq(@_)};ref$xtext_sub or $xtext_sub=sub {shift()->$expand_text(@_)};ref$xptree_sub or $xptree_sub=sub {shift()->$expand_ptree(@_)};my$seq=Pod::ParseTree->new();my@seq_stack=($seq);my ($ldelim,$rdelim)=('','');$_=$text;my@tokens=split /([A-Z]<(?:<+(?:\r?\n|[ \t]))?)/;while (@tokens){$_=shift@tokens;if (/^([A-Z])(<(?:<+(?:\r?\n|[ \t]))?)$/){my$ldelim_orig;($cmd,$ldelim_orig)=($1,$2);($ldelim=$ldelim_orig)=~ s/\s+$//;($rdelim=$ldelim)=~ tr/</>/;$seq=Pod::InteriorSequence->new(-name=>$cmd,-ldelim=>$ldelim_orig,-rdelim=>$rdelim,-file=>$file,-line=>$line);(@seq_stack > 1)and $seq->nested($seq_stack[-1]);push@seq_stack,$seq}elsif (@seq_stack > 1){my ($seq_end,$post_seq)=('','');if (($ldelim eq '<' and /\A(.*?)(>)/s)or /\A(.*?)(\s+$rdelim)/s){$post_seq=substr($_,length($1)+ length($2));($_,$seq_end)=($1,$2);(length$post_seq)and unshift@tokens,$post_seq}if (length){$seq->append($expand_text ? &$xtext_sub($self,$_,$seq): $_);$_ .= $seq_end}if (length$seq_end){$seq->rdelim($seq_end);pop@seq_stack;$seq_stack[-1]->append($expand_seq ? &$xseq_sub($self,$seq): $seq);if(@seq_stack > 1){$cmd=$seq_stack[-1]->name;$ldelim=$seq_stack[-1]->ldelim;$rdelim=$seq_stack[-1]->rdelim}else {$cmd=$ldelim=$rdelim=''}}}elsif (length){$seq->append($expand_text ? &$xtext_sub($self,$_,$seq): $_)}$line += /\n/;$seq=$seq_stack[-1]}my$errorsub=(@seq_stack > 1)? $self->errorsub(): undef;while (@seq_stack > 1){($cmd,$file,$line)=($seq->name,$seq->file_line);$ldelim=$seq->ldelim;($rdelim=$ldelim)=~ tr/</>/;$rdelim =~ s/^(\S+)(\s*)$/$2$1/;pop@seq_stack;my$errmsg="*** ERROR: unterminated ${cmd}${ldelim}...${rdelim}"." at line $line in file $file\n";(ref$errorsub)and &{$errorsub}($errmsg)or (defined$errorsub)and $self->$errorsub($errmsg)or carp($errmsg);$seq_stack[-1]->append($expand_seq ? &$xseq_sub($self,$seq): $seq);$seq=$seq_stack[-1]}my$ptree=(pop@seq_stack)->parse_tree;return$expand_ptree ? &$xptree_sub($self,$ptree): $ptree}sub interpolate {my($self,$text,$line_num)=@_;my%parse_opts=(-expand_seq=>'interior_sequence');my$ptree=$self->parse_text(\%parse_opts,$text,$line_num);return join '',$ptree->children()}sub parse_paragraph {my ($self,$text,$line_num)=@_;local*myData=$self;local*myOpts=($myData{_PARSEOPTS}||= {});local $_;my$wantNonPods=$myOpts{'-want_nonPODs'};$myData{_CUTTING}=0 if$text =~ /^={1,2}\S/;$wantNonPods and $text=$self->preprocess_paragraph($text,$line_num);return if$myData{_CUTTING};if (exists$myData{_SELECTED_SECTIONS}){$self->is_selected($text)or return ($myData{_CUTTING}=1)}unless ($wantNonPods){$text=$self->preprocess_paragraph($text,$line_num);return 1 unless ((defined$text)and (length$text));return 1 if ($myData{_CUTTING})}my ($pfx,$cmd,$arg,$sep)=('','','','');my$pod_para=undef;if ($text =~ /^(={1,2})(?=\S)/){$pfx=$1;$_=substr($text,length$pfx);($cmd,$sep,$text)=split /(\s+)/,$_,2;$sep='' unless defined$sep;$text='' unless defined$text;if ($cmd eq 'cut'){$myData{_CUTTING}=1;return unless$myOpts{'-process_cut_cmd'}}}$pod_para=new Pod::Paragraph(-name=>$cmd,-text=>$text,-prefix=>$pfx,-separator=>$sep,-file=>$myData{_INFILE},-line=>$line_num);if ($myData{_WHITESPACE}and $myOpts{'-warnings'}and not ($text =~ /^\s+/ and ($myData{_PREVIOUS}||"")eq "verbatim")){my$errorsub=$self->errorsub();my$line=$line_num - 1;my$errmsg="*** WARNING: line containing nothing but whitespace"." in paragraph at line $line in file $myData{_INFILE}\n";(ref$errorsub)and &{$errorsub}($errmsg)or (defined$errorsub)and $self->$errorsub($errmsg)or carp($errmsg)}if (length$cmd){$self->command($cmd,$text,$line_num,$pod_para);$myData{_PREVIOUS}=$cmd}elsif ($text =~ /^\s+/){$self->verbatim($text,$line_num,$pod_para);$myData{_PREVIOUS}="verbatim"}else {$self->textblock($text,$line_num,$pod_para);$myData{_PREVIOUS}="textblock"}$myData{_WHITESPACE}=$text =~ /^[^\S\r\n]+\r*\Z/m ? 1 : 0;return 1}sub parse_from_filehandle {my$self=shift;my%opts=(ref $_[0]eq 'HASH')? %{shift()}: ();my ($in_fh,$out_fh)=@_;$in_fh=\*STDIN unless ($in_fh);local*myData=$self;local*myOpts=($myData{_PARSEOPTS}||= {});local $_;my$topstream=$self->_push_input_stream($in_fh,$out_fh);(exists$opts{-cutting})and $self->cutting($opts{-cutting});my ($textline,$paragraph)=('','');my ($nlines,$plines)=(0,0);$_=ref$in_fh;my$tied_fh=(/^(?:GLOB|FileHandle|IO::\w+)$/ or tied$in_fh);while (defined ($textline=$tied_fh ? <$in_fh> : $in_fh->getline)){$textline=$self->preprocess_line($textline,++$nlines);next unless ((defined$textline)&& (length$textline));if ((!length$paragraph)&& ($textline =~ /^==/)){$paragraph=$textline;$plines=1;$textline=''}else {$paragraph .= $textline;++$plines}next unless (($textline =~ /^[^\S\r\n]*[\r\n]*$/)&& (length$paragraph));parse_paragraph($self,$paragraph,($nlines - $plines)+ 1);$paragraph='';$plines=0}if (length$paragraph){parse_paragraph($self,$paragraph,($nlines - $plines)+ 1)}$self->_pop_input_stream()}sub parse_from_file {my$self=shift;my%opts=(ref $_[0]eq 'HASH')? %{shift()}: ();my ($infile,$outfile)=@_;my ($in_fh,$out_fh);if ($] < 5.006){($in_fh,$out_fh)=(gensym(),gensym())}my ($close_input,$close_output)=(0,0);local*myData=$self;local*_;if (defined$infile && ref$infile){if (ref($infile)=~ /^(SCALAR|ARRAY|HASH|CODE|REF)$/){croak "Input from $1 reference not supported!\n"}$myData{_INFILE}=${$infile};$in_fh=$infile}elsif (!defined($infile)||!length($infile)|| ($infile eq '-')|| ($infile =~ /^<&(?:STDIN|0)$/i)){$infile ||= '-';$myData{_INFILE}='<standard input>';$in_fh=\*STDIN}else {$myData{_INFILE}=$infile;open($in_fh,"< $infile")or croak "Can't open $infile for reading: $!\n";$close_input=1}if (ref$outfile){if (ref($outfile)=~ /^(ARRAY|HASH|CODE)$/){croak "Output to $1 reference not supported!\n"}elsif (ref($outfile)eq 'SCALAR'){croak "Output to SCALAR reference not supported!\n"}else {$myData{_OUTFILE}=${$outfile};$out_fh=$outfile}}elsif (!defined($outfile)||!length($outfile)|| ($outfile eq '-')|| ($outfile =~ /^>&?(?:STDOUT|1)$/i)){if (defined$myData{_TOP_STREAM}){$out_fh=$myData{_OUTPUT}}else {$outfile ||= '-';$myData{_OUTFILE}='<standard output>';$out_fh=\*STDOUT}}elsif ($outfile =~ /^>&(STDERR|2)$/i){$myData{_OUTFILE}='<standard error>';$out_fh=\*STDERR}else {$myData{_OUTFILE}=$outfile;(-d $outfile)and croak "$outfile is a directory, not POD input!\n";open($out_fh,"> $outfile")or croak "Can't open $outfile for writing: $!\n";$close_output=1}$self->parse_from_filehandle(\%opts,$in_fh,$out_fh);$close_input and close($in_fh)|| croak "Can't close $infile after reading: $!\n";$close_output and close($out_fh)|| croak "Can't close $outfile after writing: $!\n"}sub errorsub {return (@_ > 1)? ($_[0]->{_ERRORSUB}=$_[1]): $_[0]->{_ERRORSUB}}sub cutting {return (@_ > 1)? ($_[0]->{_CUTTING}=$_[1]): $_[0]->{_CUTTING}}sub parseopts {local*myData=shift;local*myOpts=($myData{_PARSEOPTS}||= {});return%myOpts if (@_==0);if (@_==1){local $_=shift;return ref($_)? $myData{_PARSEOPTS}=$_ : $myOpts{$_}}my@newOpts=(%myOpts,@_);$myData{_PARSEOPTS}={@newOpts }}sub output_file {return $_[0]->{_OUTFILE}}sub output_handle {return $_[0]->{_OUTPUT}}sub input_file {return $_[0]->{_INFILE}}sub input_handle {return $_[0]->{_INPUT}}sub input_streams {return $_[0]->{_INPUT_STREAMS}}sub top_stream {return $_[0]->{_TOP_STREAM}|| undef}sub _push_input_stream {my ($self,$in_fh,$out_fh)=@_;local*myData=$self;unless (defined$myData{_TOP_STREAM}){$out_fh=\*STDOUT unless (defined$out_fh);$myData{_CUTTING}=1;$myData{_INPUT_STREAMS}=[]}$myData{_OUTFILE}='(unknown)' unless (defined$myData{_OUTFILE});$myData{_OUTPUT}=$out_fh if (defined$out_fh);$in_fh=\*STDIN unless (defined$in_fh);$myData{_INFILE}='(unknown)' unless (defined$myData{_INFILE});$myData{_INPUT}=$in_fh;my$input_top=$myData{_TOP_STREAM}=new Pod::InputSource(-name=>$myData{_INFILE},-handle=>$in_fh,-was_cutting=>$myData{_CUTTING});local*input_stack=$myData{_INPUT_STREAMS};push(@input_stack,$input_top);$self->begin_pod()if (@input_stack==1);$self->begin_input();return$input_top}sub _pop_input_stream {my ($self)=@_;local*myData=$self;local*input_stack=$myData{_INPUT_STREAMS};$self->end_input()if (@input_stack > 0);$self->end_pod()if (@input_stack==1);my$old_top=pop(@input_stack);$myData{_CUTTING}=$old_top->was_cutting();my$input_top=undef;if (@input_stack > 0){$input_top=$myData{_TOP_STREAM}=$input_stack[-1];$myData{_INFILE}=$input_top->name();$myData{_INPUT}=$input_top->handle()}else {delete$myData{_TOP_STREAM};delete$myData{_INPUT_STREAMS}}return$input_top}1;