package Pod::Select;use strict;use vars qw($VERSION @ISA @EXPORT $MAX_HEADING_LEVEL %myData @section_headings @selected_sections);$VERSION='1.63';require 5.005;use Carp;use Pod::Parser 1.04;@ISA=qw(Pod::Parser);@EXPORT=qw(&podselect);*MAX_HEADING_LEVEL=\3;sub _init_headings {my$self=shift;local*myData=$self;unless (defined$myData{_SECTION_HEADINGS}){local*section_headings=$myData{_SECTION_HEADINGS}=[];for (my$i=0;$i < $MAX_HEADING_LEVEL;++$i){$section_headings[$i]=''}}}sub curr_headings {my$self=shift;$self->_init_headings()unless (defined$self->{_SECTION_HEADINGS});my@headings=@{$self->{_SECTION_HEADINGS}};return (@_ > 0 and $_[0]=~ /^\d+$/)? $headings[$_[0]- 1]: @headings}sub select {my ($self,@sections)=@_;local*myData=$self;local $_;my$add=($sections[0]eq '+')? shift(@sections): '';unless (@sections){delete$myData{_SELECTED_SECTIONS}unless ($add);return}$myData{_SELECTED_SECTIONS}=[]unless ($add && exists$myData{_SELECTED_SECTIONS});local*selected_sections=$myData{_SELECTED_SECTIONS};for my$spec (@sections){if (defined($_=_compile_section_spec($spec))){push(@selected_sections,$_)}else {carp qq{Ignoring section spec "$spec"!\n}}}}sub add_selection {my$self=shift;return$self->select('+',@_)}sub clear_selections {my$self=shift;return$self->select()}sub match_section {my$self=shift;my (@headings)=@_;local*myData=$self;my$selections=(exists$myData{_SELECTED_SECTIONS})? $myData{_SELECTED_SECTIONS}: undef;return 1 unless ((defined$selections)&& @{$selections});my@current_headings=$self->curr_headings();for (my$i=0;$i < $MAX_HEADING_LEVEL;++$i){(defined$headings[$i])or $headings[$i]=$current_headings[$i]}for my$section_spec (@{$selections}){my$match=1;for (my$i=0;$i < $MAX_HEADING_LEVEL;++$i){my$regex=$section_spec->[$i];my$negated=($regex =~ s/^\!//);$match &= ($negated ? ($headings[$i]!~ /${regex}/): ($headings[$i]=~ /${regex}/));last unless ($match)}return 1 if ($match)}return 0}sub is_selected {my ($self,$paragraph)=@_;local $_;local*myData=$self;$self->_init_headings()unless (defined$myData{_SECTION_HEADINGS});$_=$paragraph;if (/^=((?:sub)*)(?:head(?:ing)?|sec(?:tion)?)(\d*)\s+(.*?)\s*$/){my ($level,$heading)=($2,$3);$level=1 + (length($1)/ 3)if ((!length$level)|| (length $1));$myData{_SECTION_HEADINGS}->[$level - 1]=$heading;for (my$i=$level;$i < $MAX_HEADING_LEVEL;++$i){$myData{_SECTION_HEADINGS}->[$i]=''}}return$self->match_section()}sub podselect {my(@argv)=@_;my%defaults=();my$pod_parser=new Pod::Select(%defaults);my$num_inputs=0;my$output='>&STDOUT';my%opts;local $_;for (@argv){my$ref=ref($_);if ($ref && $ref eq 'HASH'){%opts=(%defaults,%{$_});%opts=map {my ($key,$val)=(lc $_,$opts{$_});$key =~ s/^(?=\w)/-/;$key =~ /^-se[cl]/ and $key='-sections';($key=>$val)}(keys%opts);(exists$opts{'-output'})and $output=$opts{'-output'};$pod_parser->select(@{$opts{'-sections'}})if ((defined$opts{'-sections'})&& ((ref$opts{'-sections'})eq 'ARRAY'))}elsif(!$ref || $ref eq 'GLOB'){$pod_parser->parse_from_file($_,$output);++$num_inputs}else {croak "Input from $ref reference not supported!\n"}}$pod_parser->parse_from_file('-')unless ($num_inputs > 0)}sub _compile_section_spec {my ($section_spec)=@_;my (@regexs,$negated);local $_=$section_spec;s{\\\\}{\001}g;s{\\/}{\002}g;@regexs=split(/\//,$_,$MAX_HEADING_LEVEL);for (my$i=0;$i < $MAX_HEADING_LEVEL;++$i){$regexs[$i]='.*' unless ((defined$regexs[$i])&& (length$regexs[$i]))}my$bad_regexs=0;for (@regexs){$_ .= '.+' if ($_ eq '!');s{\001}{\\\\}g;s{\002}{\\/}g;$negated=s/^\!//;eval "m{$_}";if ($@){++$bad_regexs;carp qq{Bad regular expression /$_/ in "$section_spec": $@\n}}else {$_='^' .$_ unless (/^\^/);$_=$_ .'$' unless (/\$$/);$_='!' .$_ if ($negated)}}return (!$bad_regexs)? [@regexs ]: undef}1;