package Archive::Zip;use 5.006;use strict;use Carp ();use Cwd ();use IO::File ();use IO::Seekable ();use Compress::Raw::Zlib ();use File::Spec ();use File::Temp ();use FileHandle ();use vars qw($VERSION @ISA);BEGIN {$VERSION='1.67';require Exporter;@ISA=qw(Exporter)}use vars qw($ChunkSize $ErrorHandler);BEGIN {$ChunkSize ||= 32768;$ErrorHandler=\&Carp::carp}use vars qw(@EXPORT_OK %EXPORT_TAGS);BEGIN {@EXPORT_OK=('computeCRC32');%EXPORT_TAGS=(CONSTANTS=>[qw(ZIP64_SUPPORTED FA_MSDOS FA_UNIX GPBF_ENCRYPTED_MASK GPBF_DEFLATING_COMPRESSION_MASK GPBF_HAS_DATA_DESCRIPTOR_MASK COMPRESSION_STORED COMPRESSION_DEFLATED COMPRESSION_LEVEL_NONE COMPRESSION_LEVEL_DEFAULT COMPRESSION_LEVEL_FASTEST COMPRESSION_LEVEL_BEST_COMPRESSION IFA_TEXT_FILE_MASK IFA_TEXT_FILE IFA_BINARY_FILE ZIP64_AS_NEEDED ZIP64_EOCD ZIP64_HEADERS) ],MISC_CONSTANTS=>[qw(FA_AMIGA FA_VAX_VMS FA_VM_CMS FA_ATARI_ST FA_OS2_HPFS FA_MACINTOSH FA_Z_SYSTEM FA_CPM FA_TOPS20 FA_WINDOWS_NTFS FA_QDOS FA_ACORN FA_VFAT FA_MVS FA_BEOS FA_TANDEM FA_THEOS GPBF_IMPLODING_8K_SLIDING_DICTIONARY_MASK GPBF_IMPLODING_3_SHANNON_FANO_TREES_MASK GPBF_IS_COMPRESSED_PATCHED_DATA_MASK COMPRESSION_SHRUNK DEFLATING_COMPRESSION_NORMAL DEFLATING_COMPRESSION_MAXIMUM DEFLATING_COMPRESSION_FAST DEFLATING_COMPRESSION_SUPER_FAST COMPRESSION_REDUCED_1 COMPRESSION_REDUCED_2 COMPRESSION_REDUCED_3 COMPRESSION_REDUCED_4 COMPRESSION_IMPLODED COMPRESSION_TOKENIZED COMPRESSION_DEFLATED_ENHANCED COMPRESSION_PKWARE_DATA_COMPRESSION_LIBRARY_IMPLODED) ],ERROR_CODES=>[qw(AZ_OK AZ_STREAM_END AZ_ERROR AZ_FORMAT_ERROR AZ_IO_ERROR) ],PKZIP_CONSTANTS=>[qw(SIGNATURE_FORMAT SIGNATURE_LENGTH LOCAL_FILE_HEADER_SIGNATURE LOCAL_FILE_HEADER_FORMAT LOCAL_FILE_HEADER_LENGTH DATA_DESCRIPTOR_SIGNATURE DATA_DESCRIPTOR_FORMAT DATA_DESCRIPTOR_LENGTH DATA_DESCRIPTOR_ZIP64_FORMAT DATA_DESCRIPTOR_ZIP64_LENGTH DATA_DESCRIPTOR_FORMAT_NO_SIG DATA_DESCRIPTOR_LENGTH_NO_SIG DATA_DESCRIPTOR_ZIP64_FORMAT_NO_SIG DATA_DESCRIPTOR_ZIP64_LENGTH_NO_SIG CENTRAL_DIRECTORY_FILE_HEADER_SIGNATURE CENTRAL_DIRECTORY_FILE_HEADER_FORMAT CENTRAL_DIRECTORY_FILE_HEADER_LENGTH ZIP64_END_OF_CENTRAL_DIRECTORY_RECORD_SIGNATURE ZIP64_END_OF_CENTRAL_DIRECTORY_RECORD_FORMAT ZIP64_END_OF_CENTRAL_DIRECTORY_RECORD_LENGTH ZIP64_END_OF_CENTRAL_DIRECTORY_LOCATOR_SIGNATURE ZIP64_END_OF_CENTRAL_DIRECTORY_LOCATOR_FORMAT ZIP64_END_OF_CENTRAL_DIRECTORY_LOCATOR_LENGTH END_OF_CENTRAL_DIRECTORY_SIGNATURE END_OF_CENTRAL_DIRECTORY_FORMAT END_OF_CENTRAL_DIRECTORY_LENGTH ZIP64_END_OF_CENTRAL_DIRECTORY_RECORD_SIGNATURE_STRING ZIP64_END_OF_CENTRAL_DIRECTORY_LOCATOR_SIGNATURE_STRING END_OF_CENTRAL_DIRECTORY_SIGNATURE_STRING) ],UTILITY_METHODS=>[qw(_error _printError _ioError _formatError _zip64NotSupported _subclassResponsibility _binmode _isSeekable _newFileHandle _readSignature _asZipDirName) ],);Exporter::export_ok_tags(qw(CONSTANTS ERROR_CODES PKZIP_CONSTANTS UTILITY_METHODS MISC_CONSTANTS))}use constant ZIP64_SUPPORTED=>!!eval {pack("Q<",1)};use constant AZ_OK=>0;use constant AZ_STREAM_END=>1;use constant AZ_ERROR=>2;use constant AZ_FORMAT_ERROR=>3;use constant AZ_IO_ERROR=>4;use constant FA_MSDOS=>0;use constant FA_AMIGA=>1;use constant FA_VAX_VMS=>2;use constant FA_UNIX=>3;use constant FA_VM_CMS=>4;use constant FA_ATARI_ST=>5;use constant FA_OS2_HPFS=>6;use constant FA_MACINTOSH=>7;use constant FA_Z_SYSTEM=>8;use constant FA_CPM=>9;use constant FA_TOPS20=>10;use constant FA_WINDOWS_NTFS=>11;use constant FA_QDOS=>12;use constant FA_ACORN=>13;use constant FA_VFAT=>14;use constant FA_MVS=>15;use constant FA_BEOS=>16;use constant FA_TANDEM=>17;use constant FA_THEOS=>18;use constant GPBF_ENCRYPTED_MASK=>1 << 0;use constant GPBF_DEFLATING_COMPRESSION_MASK=>3 << 1;use constant GPBF_HAS_DATA_DESCRIPTOR_MASK=>1 << 3;use constant DEFLATING_COMPRESSION_NORMAL=>0 << 1;use constant DEFLATING_COMPRESSION_MAXIMUM=>1 << 1;use constant DEFLATING_COMPRESSION_FAST=>2 << 1;use constant DEFLATING_COMPRESSION_SUPER_FAST=>3 << 1;use constant COMPRESSION_STORED=>0;use constant COMPRESSION_DEFLATED=>8;use constant COMPRESSION_LEVEL_NONE=>0;use constant COMPRESSION_LEVEL_DEFAULT=>-1;use constant COMPRESSION_LEVEL_FASTEST=>1;use constant COMPRESSION_LEVEL_BEST_COMPRESSION=>9;use constant IFA_TEXT_FILE_MASK=>1;use constant IFA_TEXT_FILE=>1;use constant IFA_BINARY_FILE=>0;use constant ZIP64_AS_NEEDED=>0;use constant ZIP64_EOCD=>1;use constant ZIP64_HEADERS=>2;use constant SIGNATURE_FORMAT=>"V";use constant SIGNATURE_LENGTH=>4;use constant LOCAL_FILE_HEADER_SIGNATURE=>0x04034b50;use constant LOCAL_FILE_HEADER_FORMAT=>"v3 V4 v2";use constant LOCAL_FILE_HEADER_LENGTH=>26;use constant DATA_DESCRIPTOR_SIGNATURE=>0x08074b50;use constant DATA_DESCRIPTOR_FORMAT=>"V3";use constant DATA_DESCRIPTOR_LENGTH=>12;use constant DATA_DESCRIPTOR_ZIP64_FORMAT=>"L< Q<2";use constant DATA_DESCRIPTOR_ZIP64_LENGTH=>20;use constant DATA_DESCRIPTOR_FORMAT_NO_SIG=>"V2";use constant DATA_DESCRIPTOR_LENGTH_NO_SIG=>8;use constant DATA_DESCRIPTOR_ZIP64_FORMAT_NO_SIG=>"Q<2";use constant DATA_DESCRIPTOR_ZIP64_LENGTH_NO_SIG=>16;use constant CENTRAL_DIRECTORY_FILE_HEADER_SIGNATURE=>0x02014b50;use constant CENTRAL_DIRECTORY_FILE_HEADER_FORMAT=>"C2 v3 V4 v5 V2";use constant CENTRAL_DIRECTORY_FILE_HEADER_LENGTH=>42;use constant ZIP64_END_OF_CENTRAL_DIRECTORY_RECORD_SIGNATURE=>0x06064b50;use constant ZIP64_END_OF_CENTRAL_DIRECTORY_RECORD_SIGNATURE_STRING=>pack("V",ZIP64_END_OF_CENTRAL_DIRECTORY_RECORD_SIGNATURE);use constant ZIP64_END_OF_CENTRAL_DIRECTORY_RECORD_FORMAT=>"Q< S<2 L<2 Q<4";use constant ZIP64_END_OF_CENTRAL_DIRECTORY_RECORD_LENGTH=>52;use constant ZIP64_END_OF_CENTRAL_DIRECTORY_LOCATOR_SIGNATURE=>0x07064b50;use constant ZIP64_END_OF_CENTRAL_DIRECTORY_LOCATOR_SIGNATURE_STRING=>pack("V",ZIP64_END_OF_CENTRAL_DIRECTORY_LOCATOR_SIGNATURE);use constant ZIP64_END_OF_CENTRAL_DIRECTORY_LOCATOR_FORMAT=>"L< Q< L<";use constant ZIP64_END_OF_CENTRAL_DIRECTORY_LOCATOR_LENGTH=>16;use constant END_OF_CENTRAL_DIRECTORY_SIGNATURE=>0x06054b50;use constant END_OF_CENTRAL_DIRECTORY_SIGNATURE_STRING=>pack("V",END_OF_CENTRAL_DIRECTORY_SIGNATURE);use constant END_OF_CENTRAL_DIRECTORY_FORMAT=>"v4 V2 v";use constant END_OF_CENTRAL_DIRECTORY_LENGTH=>18;use constant GPBF_IMPLODING_8K_SLIDING_DICTIONARY_MASK=>1 << 1;use constant GPBF_IMPLODING_3_SHANNON_FANO_TREES_MASK=>1 << 2;use constant GPBF_IS_COMPRESSED_PATCHED_DATA_MASK=>1 << 5;use constant COMPRESSION_SHRUNK=>1;use constant COMPRESSION_REDUCED_1=>2;use constant COMPRESSION_REDUCED_2=>3;use constant COMPRESSION_REDUCED_3=>4;use constant COMPRESSION_REDUCED_4=>5;use constant COMPRESSION_IMPLODED=>6;use constant COMPRESSION_TOKENIZED=>7;use constant COMPRESSION_DEFLATED_ENHANCED=>9;use constant COMPRESSION_PKWARE_DATA_COMPRESSION_LIBRARY_IMPLODED=>10;require Archive::Zip::Archive;require Archive::Zip::Member;require Archive::Zip::FileMember;require Archive::Zip::DirectoryMember;require Archive::Zip::ZipFileMember;require Archive::Zip::NewFileMember;require Archive::Zip::StringMember;sub _ISA ($$) {local $@;!!eval {ref $_[0]and $_[0]->isa($_[1])}}sub _CAN ($$) {local $@;!!eval {ref $_[0]and $_[0]->can($_[1])}}sub new {my$class=shift;return Archive::Zip::Archive->new(@_)}sub computeCRC32 {my ($data,$crc);if (ref($_[0])eq 'HASH'){$data=$_[0]->{string};$crc=$_[0]->{checksum}}else {$data=shift;$data=shift if ref($data);$crc=shift}return Compress::Raw::Zlib::crc32($data,$crc)}sub setChunkSize {shift if ref($_[0])eq 'Archive::Zip::Archive';my$chunkSize=(ref($_[0])eq 'HASH')? shift->{chunkSize}: shift;my$oldChunkSize=$Archive::Zip::ChunkSize;$Archive::Zip::ChunkSize=$chunkSize if ($chunkSize);return$oldChunkSize}sub chunkSize {return$Archive::Zip::ChunkSize}sub setErrorHandler {my$errorHandler=(ref($_[0])eq 'HASH')? shift->{subroutine}: shift;$errorHandler=\&Carp::carp unless defined($errorHandler);my$oldErrorHandler=$Archive::Zip::ErrorHandler;$Archive::Zip::ErrorHandler=$errorHandler;return$oldErrorHandler}sub _printError {my$string=join(' ',@_,"\n");my$oldCarpLevel=$Carp::CarpLevel;$Carp::CarpLevel += 2;&{$ErrorHandler}($string);$Carp::CarpLevel=$oldCarpLevel}sub _formatError {shift if ref($_[0]);_printError('format error:',@_);return AZ_FORMAT_ERROR}sub _ioError {shift if ref($_[0]);_printError('IO error:',@_,':',$!);return AZ_IO_ERROR}sub _error {shift if ref($_[0]);_printError('error:',@_);return AZ_ERROR}sub _zip64NotSupported {shift if ref($_[0]);_printError('zip64 format not supported on this Perl interpreter');return AZ_ERROR}sub _subclassResponsibility {Carp::croak("subclass Responsibility\n")}sub _binmode {my$fh=shift;return _CAN($fh,'binmode')? $fh->binmode(): binmode($fh)}sub _isSeekable {my$fh=shift;return 0 unless ref$fh;_ISA($fh,"IO::Scalar")and return 0;_ISA($fh,"IO::String")and return 1;if (_ISA($fh,"IO::Seekable")){_ISA($fh,"FileHandle")and return 0;return 1}ref$fh eq "GLOB" && eval {seek$fh,0,1}and return 1;_CAN($fh,"stat")and return -f $fh;return (_CAN($fh,"seek")and _CAN($fh,"tell"))? 1 : 0}sub _print {my ($self,$fh,@data)=@_;local $\;return$fh->print(@data)}sub _newFileHandle {my$fd=shift;my$status=1;my$handle;if (ref($fd)){if (_ISA($fd,'IO::Scalar')or _ISA($fd,'IO::String')){$handle=$fd}elsif (_ISA($fd,'IO::Handle')or ref($fd)eq 'GLOB'){$handle=IO::File->new;$status=$handle->fdopen($fd,@_)}else {$handle=$fd}}else {$handle=IO::File->new;$status=$handle->open($fd,@_)}return ($status,$handle)}sub _readSignature {my$fh=shift;my$fileName=shift;my$expectedSignature=shift;my$noFormatError=shift;my$signatureData;my$bytesRead=$fh->read($signatureData,SIGNATURE_LENGTH);if ($bytesRead!=SIGNATURE_LENGTH){return _ioError("reading header signature")}my$signature=unpack(SIGNATURE_FORMAT,$signatureData);my$status=AZ_OK;if ((defined($expectedSignature)&& $signature!=$expectedSignature)|| (!defined($expectedSignature)&& $signature!=CENTRAL_DIRECTORY_FILE_HEADER_SIGNATURE && $signature!=LOCAL_FILE_HEADER_SIGNATURE && $signature!=END_OF_CENTRAL_DIRECTORY_SIGNATURE && $signature!=DATA_DESCRIPTOR_SIGNATURE && $signature!=ZIP64_END_OF_CENTRAL_DIRECTORY_RECORD_SIGNATURE && $signature!=ZIP64_END_OF_CENTRAL_DIRECTORY_LOCATOR_SIGNATURE)){if (!$noFormatError){my$errmsg=sprintf("bad signature: 0x%08x",$signature);if (_isSeekable($fh)){$errmsg .= sprintf(" at offset %d",$fh->tell()- SIGNATURE_LENGTH)}$status=_formatError("$errmsg in file $fileName")}else {$status=AZ_FORMAT_ERROR}}return ($status,$signature)}sub tempFile {my$dir=(ref($_[0])eq 'HASH')? shift->{tempDir}: shift;my ($fh,$filename)=File::Temp::tempfile(SUFFIX=>'.zip',UNLINK=>1,$dir ? (DIR=>$dir): ());return (undef,undef)unless$fh;my ($status,$newfh)=_newFileHandle($fh,'w+');$fh->close();return ($newfh,$filename)}sub _asZipDirName {my$name=shift;my$forceDir=shift;my$volReturn=shift;my ($volume,$directories,$file)=File::Spec->splitpath(File::Spec->canonpath($name),$forceDir);$$volReturn=$volume if (ref($volReturn));my@dirs=map {$_ =~ s{/}{_}g;$_}File::Spec->splitdir($directories);if (@dirs > 0){pop(@dirs)unless$dirs[-1]}push(@dirs,defined($file)? $file : '');my$normalised_path=join '/',@dirs;$normalised_path =~ s{^/}{};return$normalised_path}sub _asLocalName {my$name=shift;my$volume=shift;$volume='' unless defined($volume);my@paths=split(/\//,$name);my$filename=pop(@paths);$filename='' unless defined($filename);my$localDirs=@paths ? File::Spec->catdir(@paths): '';my$localName=File::Spec->catpath($volume,$localDirs,$filename);unless ($volume){$localName=File::Spec->rel2abs($localName,Cwd::getcwd())}return$localName}1;