package ExtUtils::Constant::Base;use strict;use vars qw($VERSION);use Carp;use Text::Wrap;use ExtUtils::Constant::Utils qw(C_stringify perl_stringify);$VERSION='0.06';use constant is_perl56=>($] < 5.007 && $] > 5.005_50);sub valid_type {1}sub default_type {''}sub header {''}sub assignment_clause_for_type;sub return_statement_for_type {undef};sub return_statement_for_notdef;sub return_statement_for_notfound;sub macro_from_name {1}sub macro_from_item {1}sub macro_to_ifdef {my ($self,$macro)=@_;if (ref$macro){return$macro->[0]}if (defined$macro && $macro ne "" && $macro ne "1"){return$macro ? "#ifdef $macro\n" : "#if 0\n"}return ""}sub macro_to_ifndef {my ($self,$macro)=@_;if (ref$macro){return "$macro->[0]#else\n"}if (defined$macro && $macro ne "" && $macro ne "1"){return$macro ? "#ifndef $macro\n" : "#if 1\n"}croak "Can't generate an ifndef for unconditional code"}sub macro_to_endif {my ($self,$macro)=@_;if (ref$macro){return$macro->[1]}if (defined$macro && $macro ne "" && $macro ne "1"){return "#endif\n"}return ""}sub name_param {'name'}sub is_utf8_param {'utf8'}sub memEQ {"!memcmp"}sub memEQ_clause {my ($self,$args)=@_;my ($name,$checked_at,$indent)=@{$args}{qw(name checked_at indent)};$indent=' ' x ($indent || 4);my$front_chop;if (ref$checked_at){substr ($name,0,length $$checked_at,)='';$front_chop=C_stringify ($$checked_at);undef$checked_at}my$len=length$name;if ($len < 2){return$indent ."{\n" if (defined$checked_at and $checked_at==0)or $len==0;$checked_at=1}my$name_param=$self->name_param;if ($len < 3 and defined$checked_at){my$check;if ($checked_at==1){$check=0}elsif ($checked_at==0){$check=1}if (defined$check){my$char=C_stringify (substr$name,$check,1);return$indent ."if ($name_param" ."[$check] == '$char') {\n"}}if (($len==2 and!defined$checked_at)or ($len==3 and defined ($checked_at)and $checked_at==2)){my$char1=C_stringify (substr$name,0,1);my$char2=C_stringify (substr$name,1,1);return$indent ."if ($name_param" ."[0] == '$char1' && $name_param" ."[1] == '$char2') {\n"}if (($len==3 and defined ($checked_at)and $checked_at==1)){my$char1=C_stringify (substr$name,0,1);my$char2=C_stringify (substr$name,2,1);return$indent ."if ($name_param" ."[0] == '$char1' && $name_param" ."[2] == '$char2') {\n"}my$pointer='^';my$have_checked_last=defined ($checked_at)&& $len==$checked_at + 1;if ($have_checked_last){$pointer=C_stringify (chop$name);$len--}$name=C_stringify ($name);my$memEQ=$self->memEQ();my$body=$indent ."if ($memEQ($name_param, \"$name\", $len)) {\n";if (defined$checked_at){$body .= $indent ."/*      " .(' ' x length$memEQ).(' ' x length$name_param).(' ' x $checked_at).$pointer .(' ' x ($len - $checked_at + length$len))."    */\n"}elsif (defined$front_chop){$body .= $indent ."/*                $front_chop" .(' ' x ($len + 1 + length$len))."    */\n"}return$body}sub dump_names {my ($self,$args,@items)=@_;my ($default_type,$what,$indent,$declare_types)=@{$args}{qw(default_type what indent declare_types)};$indent=' ' x ($indent || 0);my$result;my (@simple,@complex,%used_types);for (@items){my$type;if (ref $_){$type=$_->{type}|| $default_type;if ($_->{utf8}){next if $_->{utf8}eq 'no';$_={%$_};unless (is_perl56){utf8::decode ($_->{name})}else {$_->{name}=pack 'U*',unpack 'U0U*',$_->{name}}delete $_->{utf8}}}else {$_={name=>$_};$type=$default_type}$used_types{$type}++;if ($type eq $default_type and length $_->{name}and length $_->{name}==($_->{name}=~ tr/A-Za-z0-9_//)and!defined ($_->{macro})and!defined ($_->{value})and!defined ($_->{default})and!defined ($_->{pre})and!defined ($_->{post})and!defined ($_->{def_pre})and!defined ($_->{def_post})and!defined ($_->{weight})){push@simple,$_->{name}}else {push@complex,$_}}if (!defined$declare_types){for (keys %$what){next if$used_types{$_};$declare_types++;last}}if ($declare_types){$result=$indent .'my $types = {map {($_, 1)} qw(' .join (" ",sort keys %$what).")};\n"}local$Text::Wrap::huge='overflow';local$Text::Wrap::columns=80;$result .= wrap ($indent ."my \@names = (qw(",$indent ."               ",join (" ",sort@simple).")");if (@complex){for my$item (sort {$a->{name}cmp $b->{name}}@complex){my$name=perl_stringify$item->{name};my$line=",\n$indent            {name=>\"$name\"";$line .= ", type=>\"$item->{type}\"" if defined$item->{type};for my$thing (qw (macro value default pre post def_pre def_post)){my$value=$item->{$thing};if (defined$value){if (ref$value){$line .= ", $thing=>[\"" .join ('", "',map {perl_stringify $_}@$value).'"]'}else {$line .= ", $thing=>\"" .perl_stringify($value)."\""}}}$line .= "}";$line =~ s!\*\/!\*" . "/!gs;$line =~ s!\/\*!/" . "\*!gs;$result .= $line}}$result .= ");\n";$result}sub assign {my$self=shift;my$args=shift;my ($indent,$type,$pre,$post,$item)=@{$args}{qw(indent type pre post item)};$post ||= '';my$clause;my$close;if ($pre){chomp$pre;$close="$indent}\n";$clause=$indent ."{\n";$indent .= "  ";$clause .= "$indent$pre";$clause .= ";" unless$pre =~ /;$/;$clause .= "\n"}confess "undef \$type" unless defined$type;confess "Can't generate code for type $type" unless$self->valid_type($type);$clause .= join '',map {"$indent$_\n"}$self->assignment_clause_for_type({type=>$type,item=>$item},@_);chomp$post;if (length$post){$clause .= "$post";$clause .= ";" unless$post =~ /;$/;$clause .= "\n"}my$return=$self->return_statement_for_type($type);$clause .= "$indent$return\n" if defined$return;$clause .= $close if$close;return$clause}sub return_clause {my ($self,$args,$item)=@_;my$indent=$args->{indent};my ($name,$value,$default,$pre,$post,$def_pre,$def_post,$type)=@$item{qw (name value default pre post def_pre def_post type)};$value=$name unless defined$value;my$macro=$self->macro_from_item($item);$indent=' ' x ($indent || 6);unless (defined$type){confess "undef \$type"}my$clause=$self->macro_to_ifdef($macro);$clause .= $self->assign ({indent=>$indent,type=>$type,pre=>$pre,post=>$post,item=>$item},ref$value ? @$value : $value);if (defined$macro && $macro ne "" && $macro ne "1"){$clause .= "#else\n";if (!defined$default){my$notdef=$self->return_statement_for_notdef();$clause .= "$indent$notdef\n" if defined$notdef}else {my@default=ref$default ? @$default : $default;$type=shift@default;$clause .= $self->assign ({indent=>$indent,type=>$type,pre=>$pre,post=>$post,item=>$item},@default)}}$clause .= $self->macro_to_endif($macro);return$clause}sub match_clause {my ($self,$args,$item)=@_;my ($offset,$indent)=@{$args}{qw(checked_at indent)};$indent=' ' x ($indent || 4);my$body='';my ($no,$yes,$either,$name,$inner_indent);if (ref$item eq 'ARRAY'){($yes,$no)=@$item;$either=$yes || $no;confess "$item is $either expecting hashref in [0] || [1]" unless ref$either eq 'HASH';$name=$either->{name}}else {confess "$item->{name} has utf8 flag '$item->{utf8}', should be false" if$item->{utf8};$name=$item->{name};$inner_indent=$indent}$body .= $self->memEQ_clause ({name=>$name,checked_at=>$offset,indent=>length$indent});if ($yes){$body .= $indent ."  if (" .$self->is_utf8_param .") {\n"}elsif ($no){$body .= $indent ."  if (!" .$self->is_utf8_param .") {\n"}if ($either){$body .= $self->return_clause ({indent=>4 + length$indent},$either);if ($yes and $no){$body .= $indent ."  } else {\n";$body .= $self->return_clause ({indent=>4 + length$indent},$no)}$body .= $indent ."  }\n"}else {$body .= $self->return_clause ({indent=>2 + length$indent},$item)}$body .= $indent ."}\n"}sub switch_clause {my ($self,$args,$namelen,$items,@items)=@_;my ($indent,$comment)=@{$args}{qw(indent comment)};$indent=' ' x ($indent || 2);local$Text::Wrap::huge='overflow';local$Text::Wrap::columns=80;my@names=sort map {$_->{name}}@items;my$leader=$indent .'/* ';my$follower=' ' x length$leader;my$body=$indent ."/* Names all of length $namelen.  */\n";if (defined$comment){$body=wrap ($leader,$follower,$comment)."\n";$leader=$follower}my@safe_names=@names;for (@safe_names){confess sprintf "Name '$_' is length %d, not $namelen",length unless length==$namelen;next if tr/A-Za-z0-9_//==length;$_='"' .perl_stringify ($_).'"';s!\*\/!\*"."/!gs;s!\/\*!/"."\*!gs}$body .= wrap ($leader,$follower,join (" ",@safe_names)." */")."\n";my@best=(1e38,~0);for my$i ($namelen - 1,0 .. ($namelen - 2)){my ($min,$max)=(~0,0);my%spread;if (is_perl56){tie%spread,'ExtUtils::Constant::Aaargh56Hash'}for (@names){my$char=substr $_,$i,1;my$ord=ord$char;confess "char $ord is out of range" if$ord > 255;$max=$ord if$ord > $max;$min=$ord if$ord < $min;push @{$spread{$char}},$_}my$ss;$ss += @$_ * @$_ foreach values%spread;my$rms=sqrt ($ss / keys%spread);if ($rms < $best[0]|| ($rms==$best[0]&& ($max - $min)< $best[1])){@best=($rms,$max - $min,$i,\%spread)}}confess "Internal error. Failed to pick a switch point for @names" unless defined$best[2];my ($offset,$best)=@best[2,3];$body .= $indent ."/* Offset $offset gives the best switch position.  */\n";my$do_front_chop=$offset==0 && $namelen > 2;if ($do_front_chop){$body .= $indent ."switch (*" .$self->name_param()."++) {\n"}else {$body .= $indent ."switch (" .$self->name_param()."[$offset]) {\n"}for my$char (sort keys %$best){confess sprintf "'$char' is %d bytes long, not 1",length$char if length ($char)!=1;confess sprintf "char %#X is out of range",ord$char if ord ($char)> 255;$body .= $indent ."case '" .C_stringify ($char)."':\n";for my$thisone (sort {my$l=ref$a eq 'ARRAY' ? ($a->[0]|| $->[1]): $a;my$r=ref$b eq 'ARRAY' ? ($b->[0]|| $->[1]): $b;($r->{weight}|| 0)<=> ($l->{weight}|| 0)or $l->{name}cmp $r->{name}}@{$items}{@{$best->{$char}}}){if ($do_front_chop){$body .= $self->match_clause ({indent=>2 + length$indent,checked_at=>\$char},$thisone)}else {$body .= $self->match_clause ({indent=>2 + length$indent,checked_at=>$offset},$thisone)}}$body .= $indent ."  break;\n"}$body .= $indent ."}\n";return$body}sub C_constant_return_type {"static int"}sub C_constant_prefix_param {''}sub C_constant_prefix_param_defintion {''}sub name_param_definition {"const char *" .$_[0]->name_param}sub namelen_param {'len'}sub namelen_param_definition {'size_t ' .$_[0]->namelen_param}sub C_constant_other_params {''}sub C_constant_other_params_defintion {''}sub params {''}sub dogfood {''}sub normalise_items {my$self=shift;my$args=shift;my$default_type=shift;my$what=shift;my$items=shift;my@new_items;for my$orig (@_){my ($name,$item);if (ref$orig){$name=$orig->{name};my ($type,$macro,$value)=@$orig{qw (type macro value)};$type ||= $default_type;$what->{$type}=1;$item={name=>$name,type=>$type};undef$macro if defined$macro and $macro eq $name;$item->{macro}=$macro if defined$macro;undef$value if defined$value and $value eq $name;$item->{value}=$value if defined$value;for my$key (qw(default pre post def_pre def_post weight not_constant)){my$value=$orig->{$key};$item->{$key}=$value if defined$value}}else {$name=$orig;$item={name=>$name,type=>$default_type};$what->{$default_type}=1}warn +(ref ($self)|| $self)."doesn't know how to handle values of type $_ used in macro $name" unless$self->valid_type ($item->{type});if ($name =~ tr/\0-\177//==length$name || $] < 5.005_50 || $args->{disable_utf8_duplication}){if (exists$items->{$name}){die "Multiple definitions for macro $name"}$items->{$name}=$item}else {if (exists$items->{$name}and ref$items->{$name}ne 'ARRAY'){confess "Unexpected ASCII definition for macro $name"}if ($name =~ tr/\0-\377//==length$name){$item->{utf8}='no';$items->{$name}[1]=$item;push@new_items,$item;$item={%$item}}unless (is_perl56){utf8::encode($name)}else {$name=pack 'C*',unpack 'C*',$name .pack 'U*'}if ($items->{$name}[0]){die "Multiple definitions for macro $name"}$item->{utf8}='yes';$item->{name}=$name;$items->{$name}[0]=$item;$what->{''}=1}push@new_items,$item}@new_items}sub C_constant {my ($self,$args,@items)=@_;my ($package,$subname,$default_type,$what,$indent,$breakout)=@{$args}{qw(package subname default_type types indent breakout)};$package ||= 'Foo';$subname ||= 'constant';my ($namelen,$items);if (ref$breakout){($namelen,$items)=@$breakout}else {$items={};if (is_perl56){require ExtUtils::Constant::Aaargh56Hash;tie %$items,'ExtUtils::Constant::Aaargh56Hash'}$breakout ||= 3;$default_type ||= $self->default_type();if (!ref$what){$what={map {$_=>1}split /,\s*/,($what || '')}}@items=$self->normalise_items ({},$default_type,$what,$items,@items)}my$params=$self->params ($what);my ($body,@subs);$body=$self->C_constant_return_type($params)."\n$subname (" .$self->C_constant_prefix_param_defintion($params).$self->name_param_definition($params);$body .= ", " .$self->namelen_param_definition($params)unless defined$namelen;$body .= $self->C_constant_other_params_defintion($params);$body .= ") {\n";if (defined$namelen){my$comment='When generated this function returned values for the list' .' of names given here.  However, subsequent manual editing may have' .' added or removed some.';$body .= $self->switch_clause ({indent=>2,comment=>$comment},$namelen,$items,@items)}else {$body .= "  /* Initially switch on the length of the name.  */\n";$body .= $self->dogfood ({package=>$package,subname=>$subname,default_type=>$default_type,what=>$what,indent=>$indent,breakout=>$breakout},@items);$body .= '  switch ('.$self->namelen_param().") {\n";my@by_length;for (@items){push @{$by_length[length $_->{name}]},$_}for my$i (0 .. $#by_length){next unless$by_length[$i];$body .= "  case $i:\n";if (@{$by_length[$i]}==1){my$only_thing=$by_length[$i]->[0];if ($only_thing->{utf8}){if ($only_thing->{utf8}eq 'yes'){$body .= $self->match_clause (undef,[$only_thing])}else {$body .= $self->match_clause (undef,[undef,$only_thing])}}else {$body .= $self->match_clause (undef,$only_thing)}}elsif (@{$by_length[$i]}< $breakout){$body .= $self->switch_clause ({indent=>4},$i,$items,@{$by_length[$i]})}else {my$what={};for (@{$by_length[$i]}){$what->{$_->{type}}=1;$what->{''}=1 if $_->{utf8}}$params=$self->params ($what);push@subs,$self->C_constant ({package=>$package,subname=>"${subname}_$i",default_type=>$default_type,types=>$what,indent=>$indent,breakout=>[$i,$items]},@{$by_length[$i]});$body .= "    return ${subname}_$i (" .$self->C_constant_prefix_param($params).$self->name_param($params);$body .= $self->C_constant_other_params($params);$body .= ");\n"}$body .= "    break;\n"}$body .= "  }\n"}my$notfound=$self->return_statement_for_notfound();$body .= "  $notfound\n" if$notfound;$body .= "}\n";return (@subs,$body)}1;