package File::Remove;use 5.00503;use strict;use warnings;use vars qw{@ISA @EXPORT_OK};use vars qw{$DEBUG $unlink $rmdir};our$VERSION='1.58';BEGIN {@ISA=qw{Exporter};@EXPORT_OK=qw{remove rm clear trash}}use File::Path ();use File::Glob ();use File::Spec 3.29 ();use Cwd 3.29 ();use constant DEBUG=>!!$DEBUG;use constant IS_VMS=>!!($^O eq 'VMS');use constant IS_MAC=>!!($^O eq 'darwin');use constant IS_WIN32=>!!($^O =~ /^MSWin/ or $^O eq 'cygwin');my$glue;my@CLEANUP=();sub clear (@) {my@files=expand(@_);for my$file (@files){next unless -e $file;remove(\1,$file)}push@CLEANUP,map {[$$,$_ ]}@files}END {for my$file (@CLEANUP){next unless$file->[0]==$$;next unless -e $file->[1];remove(\1,$file->[1])}}sub remove (@) {my$recursive=(ref $_[0]eq 'SCALAR')? shift : \0;my$opts=(ref $_[0]eq 'HASH')? shift : {glob=>1};my@files=_expand_with_opts ($opts,@_);my@removes;for my$path (@files){if (-l $path){print "link: $path\n" if DEBUG;if ($unlink ? $unlink->($path): unlink($path)){push@removes,$path}next}unless (-e $path){print "missing: $path\n" if DEBUG;push@removes,$path;next}my$can_delete;if (IS_VMS){$can_delete=VMS::Filespec::candelete($path)}elsif (IS_WIN32){$can_delete=1}elsif (-w $path){$can_delete=1}elsif ($<==0){$can_delete=1}elsif ((lstat($path))[4]==$<){$can_delete=1}else {$can_delete=0}unless ($can_delete){print "nowrite: $path\n" if DEBUG;next}if (-f $path){print "file: $path\n" if DEBUG;unless (-w $path){(undef,undef,my$rp)=lstat$path or next;$rp &= 07777;$rp |= 0600;chmod$rp,$path}if ($unlink ? $unlink->($path): unlink($path)){next if -e $path;push@removes,$path}}elsif (-d $path){print "dir: $path\n" if DEBUG;my$dir=File::Spec->canonpath($path);my$chdir=_moveto($dir);if (length$chdir){chdir($chdir)or next}if ($$recursive){if (File::Path::rmtree([$dir ],DEBUG,0)){next if -e $path;push@removes,$path}}else {my ($save_mode)=(stat$dir)[2];chmod$save_mode & 0777,$dir;if ($rmdir ? $rmdir->($dir): rmdir($dir)){next if -e $path;push@removes,$path}}}else {print "???: $path\n" if DEBUG}}return@removes}sub rm (@) {goto&remove}sub trash (@) {local$unlink=$unlink;local$rmdir=$rmdir;if (ref $_[0]eq 'HASH'){my%options=%{+shift @_};$unlink=$options{unlink};$rmdir=$options{rmdir}}elsif (IS_WIN32){local $@;eval 'use Win32::FileOp ();';die "Can't load Win32::FileOp to support the Recycle Bin: \$@ = $@" if length $@;$unlink=\&Win32::FileOp::Recycle;$rmdir=\&Win32::FileOp::Recycle}elsif (IS_MAC){unless ($glue){local $@;eval 'use Mac::Glue ();';die "Can't load Mac::Glue::Finder to support the Trash Can: \$@ = $@" if length $@;$glue=Mac::Glue->new('Finder')}my$code=sub {my@files=map {Mac::Glue::param_type(Mac::Glue::typeAlias()=>$_)}@_;$glue->delete(\@files)};$unlink=$code;$rmdir=$code}else {die "Support for trash() on platform '$^O' not available at this time.\n"}remove(@_)}sub undelete (@) {goto&trash}sub _expand_with_opts {my$opts=shift;return ($opts->{glob}? expand(@_): @_)}sub expand (@) {map {-e $_ ? $_ : File::Glob::bsd_glob($_)}@_}sub _moveto {my$remove=File::Spec->rel2abs(shift);my$cwd=@_ ? shift : Cwd::cwd();$remove=Cwd::abs_path($remove);$cwd=Cwd::abs_path($cwd);my ($cv,$cd)=File::Spec->splitpath($cwd,1);my ($rv,$rd)=File::Spec->splitpath($remove,1);return '' unless$cv eq $rv;my@cd=File::Spec->splitdir($cd);my@rd=File::Spec->splitdir($rd);unless (@cd >= @rd){return ''}for (0 .. $#rd){$cd[$_]eq $rd[$_]or return ''}pop@rd;return File::Spec->catpath($rv,File::Spec->catdir(@rd),'')}1;