package Net::IP;use strict;use Math::BigInt;use vars qw($VERSION @ISA @EXPORT @EXPORT_OK %EXPORT_TAGS $ERROR $ERRNO %IPv4ranges %IPv6ranges $useBigInt $IP_NO_OVERLAP $IP_PARTIAL_OVERLAP $IP_A_IN_B_OVERLAP $IP_B_IN_A_OVERLAP $IP_IDENTICAL);$VERSION='1.26';require Exporter;@ISA=qw(Exporter);@EXPORT=qw(&Error &Errno $IP_NO_OVERLAP $IP_PARTIAL_OVERLAP $IP_A_IN_B_OVERLAP $IP_B_IN_A_OVERLAP $IP_IDENTICAL);@EXPORT_OK=qw(&Error &Errno &ip_iptobin &ip_bintoip &ip_bintoint &ip_inttobin &ip_get_version &ip_is_ipv4 &ip_is_ipv6 &ip_expand_address &ip_get_mask &ip_last_address_bin &ip_splitprefix &ip_prefix_to_range &ip_is_valid_mask &ip_bincomp &ip_binadd &ip_get_prefix_length &ip_range_to_prefix &ip_compress_address &ip_is_overlap &ip_get_embedded_ipv4 &ip_aggregate &ip_iptype &ip_check_prefix &ip_reverse &ip_normalize &ip_normal_range &ip_iplengths $IP_NO_OVERLAP $IP_PARTIAL_OVERLAP $IP_A_IN_B_OVERLAP $IP_B_IN_A_OVERLAP $IP_IDENTICAL);%EXPORT_TAGS=(PROC=>[@EXPORT_OK],);%IPv4ranges=('00000000'=>'PRIVATE','00001010'=>'PRIVATE','0110010001'=>'SHARED','01111111'=>'LOOPBACK','1010100111111110'=>'LINK-LOCAL','101011000001'=>'PRIVATE','110000000000000000000000'=>'RESERVED','110000000000000000000010'=>'TEST-NET','110000000101100001100011'=>'6TO4-RELAY','1100000010101000'=>'PRIVATE','110001100001001'=>'RESERVED','110001100011001101100100'=>'TEST-NET','110010110000000001110001'=>'TEST-NET','1110'=>'MULTICAST','1111'=>'RESERVED','11111111111111111111111111111111'=>'BROADCAST',);%IPv6ranges=('00000000'=>'RESERVED',('0' x 128)=>'UNSPECIFIED',('0' x 127).'1'=>'LOOPBACK',('0' x 80).('1' x 16)=>'IPV4MAP','00000001'=>'RESERVED','0000000100000000' .('0' x 48)=>'DISCARD','0000001'=>'RESERVED','000001'=>'RESERVED','00001'=>'RESERVED','0001'=>'RESERVED','001'=>'GLOBAL-UNICAST','0010000000000001' .('0' x 16)=>'TEREDO','00100000000000010000000000000010' .('0' x 16)=>'BMWG','00100000000000010000110110111000'=>'DOCUMENTATION','0010000000000001000000000001'=>'ORCHID','0010000000000010'=>'6TO4','010'=>'RESERVED','011'=>'RESERVED','100'=>'RESERVED','101'=>'RESERVED','110'=>'RESERVED','1110'=>'RESERVED','11110'=>'RESERVED','111110'=>'RESERVED','1111110'=>'UNIQUE-LOCAL-UNICAST','111111100'=>'RESERVED','1111111010'=>'LINK-LOCAL-UNICAST','1111111011'=>'RESERVED','11111111'=>'MULTICAST',);$IP_NO_OVERLAP=0;$IP_PARTIAL_OVERLAP=1;$IP_A_IN_B_OVERLAP=-1;$IP_B_IN_A_OVERLAP=-2;$IP_IDENTICAL=-3;use overload ('+'=>'ip_add_num','bool'=>sub {@_},);sub ip_add_num {my$self=shift;my ($value)=@_;my$ip=$self->intip + $value;my$last=$self->last_int;if ($ip > $self->last_int){return}my$newb=ip_inttobin($ip,$self->version);$newb=ip_bintoip($newb,$self->version);my$newe=ip_inttobin($last,$self->version);$newe=ip_bintoip($newe,$self->version);my$new=new Net::IP("$newb - $newe");return ($new)}sub new {my ($class,$data,$ipversion)=(@_);my$self={};bless($self,$class);unless ($self->set($data,$ipversion)){return}return$self}sub set {my$self=shift;my ($data,$ipversion)=@_;my ($begin,$end)=ip_normalize($data,$ipversion)or do {$self->{error}=$ERROR;$self->{errno}=$ERRNO;return};for (qw(ipversion errno prefixlen binmask reverse_ip last_ip iptype binip error ip intformat hexformat mask last_bin last_int prefix is_prefix)){delete($self->{$_})}return unless ($self->{ipversion}=$ipversion || ip_get_version($begin));$self->{ip}=$begin;return unless ($self->{binip}=ip_iptobin($self->ip(),$self->version()));$self->{is_prefix}=0;$end ||= $begin;$self->{last_ip}=$end;my$ver=ip_get_version($end)|| return;if ($ver!=$self->version()){$ERRNO=201;$ERROR="Begin and End addresses have different IP versions - $begin - $end";$self->{errno}=$ERRNO;$self->{error}=$ERROR;return}return unless ($self->{last_bin}=ip_iptobin($self->last_ip(),$self->version()));unless (ip_bincomp($self->binip(),'le',$self->last_bin())){$ERRNO=202;$ERROR="Begin address is greater than End address $begin - $end";$self->{errno}=$ERRNO;$self->{error}=$ERROR;return}my@prefixes=$self->find_prefixes()or return;if (scalar(@prefixes)==1){return unless ((undef,$self->{prefixlen})=ip_splitprefix($prefixes[0]));$self->{is_prefix}=1}if ($self->{is_prefix}){$self->{binmask}=ip_get_mask($self->prefixlen(),$self->version());unless (ip_check_prefix($self->binip(),$self->prefixlen(),$self->version())){$self->{error}=$ERROR;$self->{errno}=$ERRNO;return}}return ($self)}sub print {my$self=shift;if ($self->{is_prefix}){return ($self->short().'/' .$self->prefixlen())}else {return (sprintf("%s - %s",$self->ip(),$self->last_ip()))}}sub error {my$self=shift;return$self->{error}}sub errno {my$self=shift;return$self->{errno}}sub binip {my$self=shift;return$self->{binip}}sub prefixlen {my$self=shift;return$self->{prefixlen}}sub version {my$self=shift;return$self->{ipversion}}sub ip {my$self=shift;return$self->{ip}}sub is_prefix {my$self=shift;return$self->{is_prefix}}sub binmask {my$self=shift;return$self->{binmask}}sub size {my$self=shift;my$size=new Math::BigInt($self->last_int);$size->badd(1);$size->bsub($self->intip)}sub intip {my$self=shift;return ($self->{intformat})if defined($self->{intformat});my$int=ip_bintoint($self->binip());if (!$int){$self->{error}=$ERROR;$self->{errno}=$ERRNO;return}$self->{intformat}=$int;return ($int)}sub hexip {my$self=shift;return$self->{'hexformat'}if(defined($self->{'hexformat'}));$self->{'hexformat'}=$self->intip->as_hex();return$self->{'hexformat'}}sub hexmask {my$self=shift;return$self->{hexmask}if(defined($self->{hexmask}));my$intmask=ip_bintoint($self->binmask);$self->{'hexmask'}=$intmask->as_hex();return ($self->{'hexmask'})}sub prefix {my$self=shift;if (not $self->is_prefix()){$self->{error}="IP range $self->{ip} is not a Prefix.";$self->{errno}=209;return}return ($self->{prefix})if defined($self->{prefix});my$prefix=$self->ip().'/' .$self->prefixlen();if (!$prefix){$self->{error}=$ERROR;$self->{errno}=$ERRNO;return}$self->{prefix}=$prefix;return ($prefix)}sub mask {my$self=shift;if (not $self->is_prefix()){$self->{error}="IP range $self->{ip} is not a Prefix.";$self->{errno}=209;return}return ($self->{mask})if defined($self->{mask});my$mask=ip_bintoip($self->binmask(),$self->version());if (!$mask){$self->{error}=$ERROR;$self->{errno}=$ERRNO;return}$self->{mask}=$mask;return ($mask)}sub short {my$self=shift;my$r;if ($self->version==6){$r=ip_compress_address($self->ip(),$self->version())}else {$r=ip_compress_v4_prefix($self->ip(),$self->prefixlen())}if (!defined($r)){$self->{error}=$ERROR;$self->{errno}=$ERRNO;return}return ($r)}sub iptype {my ($self)=shift;return ($self->{iptype})if defined($self->{iptype});my$type=ip_iptype($self->binip(),$self->version());if (!$type){$self->{error}=$ERROR;$self->{errno}=$ERRNO;return}$self->{iptype}=$type;return ($type)}sub reverse_ip {my ($self)=shift;if (not $self->is_prefix()){$self->{error}="IP range $self->{ip} is not a Prefix.";$self->{errno}=209;return}return ($self->{reverse_ip})if defined($self->{reverse_ip});my$rev=ip_reverse($self->ip(),$self->prefixlen(),$self->version());if (!$rev){$self->{error}=$ERROR;$self->{errno}=$ERRNO;return}$self->{reverse_ip}=$rev;return ($rev)}sub last_bin {my ($self)=shift;return ($self->{last_bin})if defined($self->{last_bin});my$last;if ($self->is_prefix()){$last=ip_last_address_bin($self->binip(),$self->prefixlen(),$self->version())}else {$last=ip_iptobin($self->last_ip(),$self->version())}if (!$last){$self->{error}=$ERROR;$self->{errno}=$ERRNO;return}$self->{last_bin}=$last;return ($last)}sub last_int {my ($self)=shift;return ($self->{last_int})if defined($self->{last_int});my$last_bin=$self->last_bin()or return;my$last_int=ip_bintoint($last_bin,$self->version())or return;$self->{last_int}=$last_int;return ($last_int)}sub last_ip {my ($self)=shift;return ($self->{last_ip})if defined($self->{last_ip});my$last=ip_bintoip($self->last_bin(),$self->version());if (!$last){$self->{error}=$ERROR;$self->{errno}=$ERRNO;return}$self->{last_ip}=$last;return ($last)}sub find_prefixes {my ($self)=@_;my@list=ip_range_to_prefix($self->binip(),$self->last_bin(),$self->version());if (!scalar(@list)){$self->{error}=$ERROR;$self->{errno}=$ERRNO;return}return (@list)}sub bincomp {my ($self,$op,$other)=@_;my$a=ip_bincomp($self->binip(),$op,$other->binip());unless (defined$a){$self->{error}=$ERROR;$self->{errno}=$ERRNO;return}return ($a)}sub binadd {my ($self,$other)=@_;my$ip=ip_binadd($self->binip(),$other->binip());if (!$ip){$self->{error}=$ERROR;$self->{errno}=$ERRNO;return}my$new=new Net::IP(ip_bintoip($ip,$self->version()))or return;return ($new)}sub aggregate {my ($self,$other)=@_;my$r=ip_aggregate($self->binip(),$self->last_bin(),$other->binip(),$other->last_bin(),$self->version());if (!$r){$self->{error}=$ERROR;$self->{errno}=$ERRNO;return}return (new Net::IP($r))}sub overlaps {my ($self,$other)=@_;my$r=ip_is_overlap($self->binip(),$self->last_bin(),$other->binip(),$other->last_bin());if (!defined($r)){$self->{error}=$ERROR;$self->{errno}=$ERRNO;return}return ($r)}sub auth {my ($self)=shift;return ($self->{auth})if defined($self->{auth});my$auth=ip_auth($self->ip,$self->version);if (!$auth){$self->{error}=$ERROR;$self->{errno}=$ERRNO;return}$self->{auth}=$auth;return ($self->{auth})}sub Error {return ($ERROR)}sub Errno {return ($ERRNO)}sub ip_iplengths {my ($version)=@_;if ($version==4){return (32)}elsif ($version==6){return (128)}else {return}}sub ip_iptobin {my ($ip,$ipversion)=@_;if ($ipversion==4){return unpack('B32',pack('C4C4C4C4',split(/\./,$ip)))}$ip =~ s/://g;unless (length($ip)==32){$ERROR="Bad IP address $ip";$ERRNO=102;return}return unpack('B128',pack('H32',$ip))}sub ip_bintoip {my ($binip,$ip_version)=@_;my$len=ip_iplengths($ip_version);if ($len < length($binip)){$ERROR="Invalid IP length for binary IP $binip\n";$ERRNO=189;return}$binip='0' x ($len - length($binip)).$binip;if ($ip_version==4){return join '.',unpack('C4C4C4C4',pack('B32',$binip))}return join(':',unpack('H4H4H4H4H4H4H4H4',pack('B128',$binip)))}sub ip_bintoint {my$binip=shift;my ($n,$dec)=(Math::BigInt->new(1),Math::BigInt->new(0));for (reverse(split '',$binip)){$_ and $dec += $n;$n *= 2}$dec =~ s/^\+//;return$dec}sub ip_inttobin {my$dec=Math::BigInt->new(shift);my$ip_version=shift;unless ($ip_version){$ERROR="Cannot determine IP version for $dec";$ERRNO=101;return}my$binip=$dec->as_bin();$binip =~ s/^0b//;my$len=ip_iplengths($ip_version);$binip='0' x ($len - length($binip)).$binip;return$binip}sub ip_get_version {my$ip=shift;$ip !~ /:/ and ip_is_ipv4($ip)and return '4';ip_is_ipv6($ip)and return '6';return}sub ip_is_ipv4 {my$ip=shift;unless ($ip =~ m/^[\d\.]+$/){$ERROR="Invalid chars in IP $ip";$ERRNO=107;return 0}if ($ip =~ m/^\./){$ERROR="Invalid IP $ip - starts with a dot";$ERRNO=103;return 0}if ($ip =~ m/\.$/){$ERROR="Invalid IP $ip - ends with a dot";$ERRNO=104;return 0}if ($ip =~ m/^(\d+)$/ and $1 < 256){return 1}my$n=($ip =~ tr/\./\./);unless ($n >= 0 and $n < 4){$ERROR="Invalid IP address $ip";$ERRNO=105;return 0}if ($ip =~ m/\.\./){$ERROR="Empty quad in IP address $ip";$ERRNO=106;return 0}for (split /\./,$ip){unless ($_ >= 0 and $_ < 256){$ERROR="Invalid quad in IP address $ip - $_";$ERRNO=107;return 0}}return 1}sub ip_is_ipv6 {my$ip=shift;my$n=($ip =~ tr/:/:/);return 0 unless ($n > 0 and $n < 8);my$k;for (split /:/,$ip){$k++;next if ($_ eq '');next if (/^[a-f\d]{1,4}$/i);if (($k==$n + 1)&& ip_is_ipv4($_)){$n++;next}$ERROR="Invalid IP address $ip";$ERRNO=108;return 0}if ($ip =~ m/^:[^:]/){$ERROR="Invalid address $ip (starts with :)";$ERRNO=109;return 0}if ($ip =~ m/[^:]:$/){$ERROR="Invalid address $ip (ends with :)";$ERRNO=110;return 0}if ($ip =~ s/:(?=:)/:/g > 1){$ERROR="Invalid address $ip (More than one :: pattern)";$ERRNO=111;return 0}if ($n!=7 && $ip !~ /::/){$ERROR="Invalid number of octets $ip";$ERRNO=112;return 0}return 1}sub ip_expand_address {my ($ip,$ip_version)=@_;unless ($ip_version){$ERROR="Cannot determine IP version for $ip";$ERRNO=101;return}if ($ip_version==4){my@quads=split /\./,$ip;if (scalar(@quads)> 4){$ERROR="Not a valid IPv address $ip";$ERRNO=102;return}my@clean_quads=(0,0,0,0);for my$q (reverse@quads){if ($q !~ m/^\d{1,3}$/){$ERROR="Not a valid IPv4 address $ip";$ERRNO=102;return}unshift(@clean_quads,$q + 1 - 1)}return (join '.',@clean_quads[0 .. 3 ])}my$num_of_double_colon=($ip =~ s/::/:!:/g);if ($num_of_double_colon > 1){$ERROR="Too many :: in ip";$ERRNO=102;return}my@ip=split /:/,$ip;my$num=scalar(@ip);for (0 .. (scalar(@ip)- 1)){if ($ip[$_]=~ /\./){$ip[$_]=substr(ip_bintoip(ip_iptobin(ip_expand_address($ip[$_],4),4),6),-9);return unless (defined($ip[$_]));$num++;next}$ip[$_]=('0' x (4 - length($ip[$_]))).$ip[$_]}for (0 .. (scalar(@ip)- 1)){next unless ($ip[$_]eq '000!');my@empty=map {$_='0' x 4}(0 .. 7);$ip[$_]=join ':',@empty[0 .. 8 - $num ];last}return (lc(join ':',@ip))}sub ip_get_mask {my ($len,$ip_version)=@_;unless ($ip_version){$ERROR="Cannot determine IP version";$ERRNO=101;return}my$size=ip_iplengths($ip_version);return (('1' x $len).('0' x ($size - $len)))}sub ip_last_address_bin {my ($binip,$len,$ip_version)=@_;unless ($ip_version){$ERROR="Cannot determine IP version";$ERRNO=101;return}my$size=ip_iplengths($ip_version);$binip=substr($binip,0,$len);return ($binip .('1' x ($size - length($binip))))}sub ip_splitprefix {my$prefix=shift;return unless ($prefix =~ m!^([^/]+?)(/\d+)?$!);my ($ip,$len)=($1,$2);defined($len)and $len =~ s!/!!;return ($ip,$len)}sub ip_prefix_to_range {my ($ip,$len,$ip_version)=@_;unless ($ip_version){$ERROR="Cannot determine IP version";$ERRNO=101;return}$ip=ip_expand_address($ip,$ip_version);my$binip=ip_iptobin($ip,$ip_version)or return;return unless (ip_check_prefix($binip,$len,$ip_version));my$lastip=ip_last_address_bin($binip,$len,$ip_version)or return;return unless ($lastip=ip_bintoip($lastip,$ip_version));return ($ip,$lastip)}sub ip_is_valid_mask {my ($mask,$ip_version)=@_;unless ($ip_version){$ERROR="Cannot determine IP version for $mask";$ERRNO=101;return}my$len=ip_iplengths($ip_version);if (length($mask)!=$len){$ERROR="Invalid mask length for $mask";$ERRNO=150;return}unless ($mask =~ m/^1*0*$/){$ERROR="Invalid mask $mask";$ERRNO=151;return}return 1}sub ip_bincomp {my ($begin,$op,$end)=@_;my ($b,$e);if ($op =~ /^l[te]$/){($b,$e)=($end,$begin)}elsif ($op =~ /^g[te]$/){($b,$e)=($begin,$end)}else {$ERROR="Invalid Operator $op\n";$ERRNO=131;return}return (1)if ($op =~ /e/ and ($begin eq $end));unless (length($b)eq length($e)){$ERROR="IP addresses of different length\n";$ERRNO=130;return}my$c;for (0 .. length($b)- 1){$c=substr($b,$_,1)- substr($e,$_,1);return (1)if ($c==1);return (0)if ($c==-1)}return 0}sub ip_binadd {my ($b,$e)=@_;unless (length($b)eq length($e)){$ERROR="IP addresses of different length\n";$ERRNO=130;return}$b=scalar(reverse$b);$e=scalar(reverse$e);my ($carry,$result,$c)=(0);for (0 .. length($b)- 1){$c=substr($b,$_,1)+ substr($e,$_,1)+ $carry;$carry=0;if ($c > 1){$c -= 2;$carry=1}$result .= $c}return scalar(reverse($result))}sub ip_get_prefix_length {my ($bin1,$bin2)=@_;unless (length($bin1)eq length($bin2)){$ERROR="IP addresses of different length\n";$ERRNO=130;return}$bin1=scalar(reverse$bin1);$bin2=scalar(reverse$bin2);for (0 .. length($bin1)- 1){return ("$_")if (substr($bin1,$_,1)eq substr($bin2,$_,1))}return length($bin1)}sub ip_range_to_prefix {my ($binip,$endbinip,$ip_version)=@_;unless ($ip_version){$ERROR="Cannot determine IP version";$ERRNO=101;return}unless (length($binip)eq length($endbinip)){$ERROR="IP addresses of different length\n";$ERRNO=130;return}my ($len,$nbits,$current,$add,@prefix);my$one=('0' x (ip_iplengths($ip_version)- 1)).'1';while (ip_bincomp($binip,'le',$endbinip)==1){if ($binip =~ m/(0+)$/){$nbits=length($1)}else {$nbits=0}do {$current=$binip;$add='1' x $nbits;$current =~ s/0{$nbits}$/$add/;$nbits--}while (ip_bincomp($current,'le',$endbinip)!=1);$len=(ip_iplengths($ip_version))- ip_get_prefix_length($binip,$current);push(@prefix,ip_bintoip($binip,$ip_version)."/$len");$binip=ip_binadd($current,$one);last if ($current =~ m/^1+$/)}return (@prefix)}sub ip_compress_v4_prefix {my ($ip,$len)=@_;my@quads=split /\./,$ip;my$qlen=int(($len - 1)/ 8);$qlen=0 if ($qlen < 0);my$newip=join '.',@quads[0 .. $qlen ];return ($newip)}sub ip_compress_address {my ($ip,$ip_version)=@_;unless ($ip_version){$ERROR="Cannot determine IP version for $ip";$ERRNO=101;return}return ($ip)if ($ip_version==4);$ip=ip_expand_address($ip,$ip_version);$ip =~ s/
	(^|:)        # Find beginning or ':' -> $1
	0+           # 1 or several 0s
	(?=          # Look-ahead
	[a-fA-F\d]+  # One or several Hexs
	(?::|$))     # ':' or end
	/$1/gx;my$reg='';while ($ip =~ m/
	((?:^|:)     # Find beginning or ':' -> $1
	0(?::0)+     # 0 followed by 1 or several ':0'
	(?::|$))     # ':' or end
	/gx){$reg=$1 if (length($reg)< length($1))}$ip =~ s/$reg/::/ if ($reg ne '');return$ip}sub ip_is_overlap {my ($b1,$e1,$b2,$e2)=(@_);my$swap;$swap=0;unless ((length($b1)eq length($e1))and (length($b2)eq length($e2))and (length($b1)eq length($b2))){$ERROR="IP addresses of different length\n";$ERRNO=130;return}unless (ip_bincomp($b1,'le',$e1)==1){$ERROR="Invalid range	$b1 - $e1";$ERRNO=140;return}unless (ip_bincomp($b2,'le',$e2)==1){$ERROR="Invalid range	$b2 - $e2";$ERRNO=140;return}if ($b1 eq $b2){return ($IP_IDENTICAL)if ($e1 eq $e2);return (ip_bincomp($e1,'lt',$e2)? $IP_A_IN_B_OVERLAP : $IP_B_IN_A_OVERLAP)}if ($e1 eq $e2){return (ip_bincomp($b1,'lt',$b2)? $IP_B_IN_A_OVERLAP : $IP_A_IN_B_OVERLAP)}if ((ip_bincomp($b1,'lt',$b2)==1)){return ($IP_NO_OVERLAP)if (ip_bincomp($e1,'lt',$b2)==1);return (ip_bincomp($e1,'lt',$e2)? $IP_PARTIAL_OVERLAP : $IP_B_IN_A_OVERLAP)}else {return ($IP_NO_OVERLAP)if (ip_bincomp($e2,'lt',$b1)==1);return (ip_bincomp($e2,'lt',$e1)? $IP_PARTIAL_OVERLAP : $IP_A_IN_B_OVERLAP)}}sub ip_get_embedded_ipv4 {my$ipv6=shift;my@ip=split /:/,$ipv6;return unless (@ip);return ($ip[-1])if (ip_is_ipv4($ip[-1]));return}sub ip_aggregate {my ($binbip1,$bineip1,$binbip2,$bineip2,$ip_version)=@_;unless ($ip_version){$ERROR="Cannot determine IP version for $binbip1";$ERRNO=101;return}my$one=(('0' x (ip_iplengths($ip_version)- 1)).'1');unless (ip_binadd($bineip1,$one)eq $binbip2){$ERROR="Ranges not contiguous - $bineip1 - $binbip2";$ERRNO=160;return}my@prefix=ip_range_to_prefix($binbip1,$bineip2,$ip_version);return if scalar(@prefix)< 1;if (scalar(@prefix)> 1){$ERROR="$binbip1 - $bineip2 is not a single prefix";$ERRNO=161;return}return ($prefix[0])}sub ip_iptype {my ($ip,$ip_version)=@_;return ip_iptypev4($ip)if$ip_version==4;return ip_iptypev6($ip)if$ip_version==6;$ERROR="IP version $ip not supported";$ERRNO=180;return}sub ip_iptypev4 {my ($ip)=@_;if ($ip !~ m/^[01]{1,32}$/){$ERROR="$ip is not a binary IPv4 address $ip";$ERRNO=180;return}for (sort {length($b)<=> length($a)}keys%IPv4ranges){return ($IPv4ranges{$_})if ($ip =~ m/^$_/)}return 'PUBLIC'}sub ip_iptypev6 {my ($ip)=@_;if ($ip !~ m/^[01]{1,128}$/){$ERROR="$ip is not a binary IPv6 address";$ERRNO=180;return}for (sort {length($b)<=> length($a)}keys%IPv6ranges){return ($IPv6ranges{$_})if ($ip =~ m/^$_/)}$ERROR="Cannot determine type for $ip";$ERRNO=180;return}sub ip_check_prefix {my ($binip,$len,$ipversion)=(@_);if ($len > length($binip)){$ERROR="Prefix length $len is longer than IP address (" .length($binip).")";$ERRNO=170;return}my$rest=substr($binip,$len);unless ($rest =~ /^0*$/){$ERROR="Invalid prefix $binip/$len";$ERRNO=171;return}unless (length($rest)+ $len==ip_iplengths($ipversion)){$ERROR="Invalid prefix length /$len";$ERRNO=172;return}return 1}sub ip_reverse {my ($ip,$len,$ip_version)=(@_);$ip_version ||= ip_get_version($ip);unless ($ip_version){$ERROR="Cannot determine IP version for $ip";$ERRNO=101;return}if ($ip_version==4){my@quads=split /\./,$ip;my$no_quads=($len / 8);my@reverse_quads=reverse@quads;while (@reverse_quads and $reverse_quads[0]==0){shift(@reverse_quads)}return join '.',@reverse_quads,'in-addr','arpa.'}elsif ($ip_version==6){my@rev_groups=reverse split /:/,ip_expand_address($ip,6);my@result;for (@rev_groups){my@revhex=reverse split //;push@result,@revhex}my$first_nibble_index=$len ? 32 - (int($len / 4)): 0;return join '.',@result[$first_nibble_index .. $#result ],'ip6','arpa.'}}sub ip_normalize {my ($data)=shift;my$ipversion;my ($len,$ip,$ip2,$real_len,$first,$last,$curr_bin,$addcst,$clen);if ($data =~ m!^(\S+?)(/\S+)$!){($ip,$len)=($1,$2);return unless ($ipversion=ip_get_version($ip));return unless ($ip=ip_expand_address($ip,$ipversion));return unless ($curr_bin=ip_iptobin($ip,$ipversion));my$one='0' x (ip_iplengths($ipversion)- 1).'1';while ($len){last unless ($len =~ s!^/(\d+)(\,|$)!!);$clen=$1;$addcst=length($2)> 0;return unless (ip_check_prefix($curr_bin,$clen,$ipversion));return unless ($curr_bin=ip_last_address_bin($curr_bin,$clen,$ipversion));if ($addcst){return unless ($curr_bin=ip_binadd($curr_bin,$one))}}return ($ip,ip_bintoip($curr_bin,$ipversion))}elsif ($data =~ /^(.+?)\s*\-\s*(.+)$/){($ip,$ip2)=($1,$2);return unless ($ipversion=ip_get_version($ip));return unless ($ip=ip_expand_address($ip,$ipversion));return unless ($ip2=ip_expand_address($ip2,$ipversion));return ($ip,$ip2)}elsif ($data =~ /^(.+?)\s+\+\s+(.+)$/){($ip,$len)=($1,$2);return unless ($ipversion=ip_get_version($ip));return unless ($ip=ip_expand_address($ip,$ipversion));my ($bin_ip);return unless ($bin_ip=ip_iptobin($ip,$ipversion));return unless ($len=ip_inttobin($len,$ipversion));return unless ($ip2=ip_binadd($bin_ip,$len));return unless ($ip2=ip_bintoip($ip2,$ipversion));return ($ip,$ip2)}else {$ip=$data;return unless ($ipversion=ip_get_version($ip));return unless ($ip=ip_expand_address($ip,$ipversion));return$ip}}sub ip_normal_range {my ($data)=shift;my ($ip1,$ip2)=ip_normalize($data);return unless ($ip1);$ip2 ||= $ip1;return ("$ip1 - $ip2")}sub ip_auth {my ($ip,$ip_version)=(@_);unless ($ip_version){$ERROR="Cannot determine IP version for $ip";$ERRNO=101;die;return}if ($ip_version!=4){$ERROR="Cannot get auth information: Not an IPv4 address";$ERRNO=308;die;return}require IP::Authority;my$reg=new IP::Authority;return ($reg->inet_atoauth($ip))}1;