package Proc::PID::File;require Exporter;@ISA=qw(Exporter);use strict;use vars qw($VERSION $RPM_Requires);use Fcntl qw(:DEFAULT :flock);$VERSION="1.29";$RPM_Requires="procps";my$RUNDIR="/var/run";my ($ME)=$0 =~ m|([^/]+)$|;my$self;sub running {$self=shift->new(@_);local*FH;my$pid=$self->read(*FH);if ($pid && $pid!=$$ && kill(0,$pid)){$self->debug("running: $pid");close FH;return$self->verify($pid)? $pid : 0}$self->write(*FH);return 0}sub new {my$class=shift;my$self=bless({},$class);%$self=&args;$self->file();$self->{debug}||= "";return$self}sub file {my$self=shift;%$self=(%$self,&args);$self->{dir}||= $RUNDIR;$self->{name}||= $ME;$self->{path}=sprintf("%s/%s.pid",$self->{dir},$self->{name})}sub alive {my$self=shift;my%args=&args;$self->{verify}=$args{verify}if$args{verify};my$pid=$self->read()|| "";$self->debug("alive(): $pid");if ($pid && $pid!=$$ && kill(0,$pid)){return$self->verify($pid)? $pid : 0}return 0}sub touch {shift->write()}sub release {my$self=shift;$self->debug("release()");unlink($self->{path})|| warn $!}sub locktime {my$self=shift;return (stat($self->{path}))[10]}sub verify {my ($self,$pid)=@_;return 1 unless$self->{verify};my$ret=0;$self->debug("verify(): OS = $^O");if ($^O =~ /linux|freebsd|cygwin|darwin/i){my$me=$self->{verify};if (!$me || $me eq "1"){$me=$ME;if ($^O eq "cygwin"){$^X =~ m|([^/]+)$|;($me=$1)=~ s/\.exe$//}}my$cols=delete($ENV{'COLUMNS'});my@ps=split m|$/|,qx/ps -fp $pid/ || die "ps utility not available: $!";s/^\s+// for@ps;$ENV{'COLUMNS'}=$cols if defined($cols);no warnings;my$n=split(/\s+/,$ps[0]);@ps=split /\s+/,$ps[1],$n;$ret=$ps[$n - 1]=~ /\Q$me\E/;}$self->debug(" - ret: [$ret]");$ret}sub read {my ($self,$fh)=@_;sysopen($fh,$self->{path},O_RDWR|O_CREAT)|| die qq/Cannot open pid file "$self->{path}": $!\n/;flock($fh,LOCK_EX | LOCK_NB)|| die qq/pid "$self->{path}" already locked: $!\n/;my ($pid)=<$fh> =~ /^(\d+)/;close$fh if @_==1;$self->debug("read(\"$self->{path}\") = " .($pid || ""));return$pid}sub write {my ($self,$fh)=@_;$self->debug("write($$)");if (@_==1){sysopen($fh,$self->{path},O_RDWR|O_CREAT)|| die qq/Cannot open pid file "$self->{path}": $!\n/;flock($fh,LOCK_EX | LOCK_NB)|| die qq/pid "$self->{path}" already locked: $!\n/}sysseek$fh,0,0;truncate$fh,0;syswrite$fh,"$$\n",length("$$\n");close$fh || die qq/Cannot write pid file "$self->{path}": $!\n/}sub args {!defined($_[0])? (): ref($_[0])? %{$_[0]}: @_}sub debug {my$self=shift;my$msg=shift || $_;$msg="> Proc::PID::File - $msg" if$self->{debug}=~ /M/;print$msg if$self->{debug}}sub DESTROY {my$self=shift;if (exists($INC{'threads.pm'})){return if threads->tid()!=0}my$pid=$self->read();$self->release()if$self->{path}&& $pid && $pid==$$}1;