use strict;use warnings;package Test::Deep;use Carp qw(confess);use Test::Deep::Cache;use Test::Deep::Stack;use Test::Deep::RegexpVersion;require overload;use Scalar::Util;my$Test;unless (defined$Test::Deep::NoTest::NoTest){require Test::Builder;$Test=Test::Builder->new}our ($Stack,%Compared,$CompareCache,%WrapCache,$Shallow);our$VERSION='1.128';$VERSION =~ tr/_//d;require Exporter;our@ISA=qw(Exporter);our$Snobby=1;our$Expects=0;our$LeafWrapper;our$DNE=\"";our$DNE_ADDR=Scalar::Util::refaddr($DNE);my@constructors=(All=>"",Any=>"",Array=>"",ArrayEach=>"array_each",ArrayElementsOnly=>"",ArrayLength=>"",ArrayLengthOnly=>"",Blessed=>"",Boolean=>"bool",Code=>"",Hash=>"",HashEach=>"hash_each",HashKeys=>"",HashKeysOnly=>"",Ignore=>"",Isa=>"Isa",ListMethods=>"",Methods=>"",None=>"",Number=>"num",Obj=>"obj_isa",RefType=>"",Regexp=>"re",RegexpMatches=>"",RegexpOnly=>"",RegexpRef=>"",RegexpRefOnly=>"",ScalarRef=>"scalref",ScalarRefOnly=>"",Shallow=>"",String=>"str",);my@CONSTRUCTORS_FROM_CLASSES;while (my ($pkg,$name)=splice@constructors,0,2){$name=lc($pkg)unless$name;my$full_pkg="Test::Deep::$pkg";my$file="$full_pkg.pm";$file =~ s#::#/#g;my$sub=sub {require$file;return$full_pkg->new(@_)};{no strict 'refs';*{$name}=$sub}push@CONSTRUCTORS_FROM_CLASSES,$name}{our@EXPORT_OK=qw(descend render_stack cmp_details deep_diag);our%EXPORT_TAGS;$EXPORT_TAGS{preload}=[];$EXPORT_TAGS{v0}=[qw(Isa blessed obj_isa all any array array_each arrayelementsonly arraylength arraylengthonly bag bool cmp_bag cmp_deeply cmp_methods cmp_set code eq_deeply hash hash_each hashkeys hashkeysonly ignore isa listmethods methods noclass none noneof num re reftype regexpmatches regexponly regexpref regexprefonly scalarrefonly scalref set shallow str subbagof subhashof subsetof superbagof superhashof supersetof useclass) ];$EXPORT_TAGS{v1}=[qw(obj_isa all any array array_each arrayelementsonly arraylength arraylengthonly bag bool cmp_bag cmp_deeply cmp_methods cmp_set code eq_deeply hash hash_each hashkeys hashkeysonly ignore listmethods methods noclass none noneof num re reftype regexpmatches regexponly regexpref regexprefonly scalarrefonly scalref set shallow str subbagof subhashof subsetof superbagof superhashof supersetof useclass) ];our@EXPORT=@{$EXPORT_TAGS{v0 }};$EXPORT_TAGS{all}=[@EXPORT,@EXPORT_OK ]}sub import {my$self=shift;my@sans_preload=grep {;$_ ne ':preload'}@_;if (@_!=@sans_preload){require Test::Deep::All;require Test::Deep::Any;require Test::Deep::Array;require Test::Deep::ArrayEach;require Test::Deep::ArrayElementsOnly;require Test::Deep::ArrayLength;require Test::Deep::ArrayLengthOnly;require Test::Deep::Blessed;require Test::Deep::Boolean;require Test::Deep::Cache::Simple;require Test::Deep::Cache;require Test::Deep::Class;require Test::Deep::Cmp;require Test::Deep::Code;require Test::Deep::Hash;require Test::Deep::HashEach;require Test::Deep::HashElements;require Test::Deep::HashKeys;require Test::Deep::HashKeysOnly;require Test::Deep::Ignore;require Test::Deep::Isa;require Test::Deep::ListMethods;require Test::Deep::Methods;require Test::Deep::MM;require Test::Deep::None;require Test::Deep::Number;require Test::Deep::Obj;require Test::Deep::Ref;require Test::Deep::RefType;require Test::Deep::Regexp;require Test::Deep::RegexpMatches;require Test::Deep::RegexpOnly;require Test::Deep::RegexpRef;require Test::Deep::RegexpRefOnly;require Test::Deep::RegexpVersion;require Test::Deep::ScalarRef;require Test::Deep::ScalarRefOnly;require Test::Deep::Set;require Test::Deep::Shallow;require Test::Deep::Stack;require Test::Deep::String}$self->export_to_level(1,$self,@_)}sub isa {if (@_==1){goto&Isa}else {goto&UNIVERSAL::isa}}sub cmp_deeply {my ($d1,$d2,$name)=@_;my ($ok,$stack)=cmp_details($d1,$d2);if (not $Test->ok($ok,$name)){my$diag=deep_diag($stack);$Test->diag($diag)}return$ok}sub cmp_details {my ($d1,$d2)=@_;local$Stack=Test::Deep::Stack->new;local$CompareCache=Test::Deep::Cache->new;local%WrapCache;my$ok=descend($d1,$d2);return ($ok,$Stack)}sub eq_deeply {my ($d1,$d2)=@_;my ($ok)=cmp_details($d1,$d2);return$ok}sub eq_deeply_cache {my ($d1,$d2,$name)=@_;local$Stack=Test::Deep::Stack->new;$CompareCache->local;my$ok=descend($d1,$d2);$CompareCache->finish($ok);return$ok}sub deep_diag {my$stack=shift;local$Stack=$stack;my$where=render_stack('$data',$stack);confess "No stack to diagnose" unless$stack;my$last=$stack->getLast;my$diag;my$message;my$got;my$expected;my$exp=$last->{exp};if (Scalar::Util::blessed($exp)){if ($exp->can("diagnostics")){$diag=$exp->diagnostics($where,$last);$diag =~ s/\n+$/\n/}else {if ($exp->can("diag_message")){$message=$exp->diag_message($where)}}}if (not defined$diag){$got=$exp->renderGot($last->{got})unless defined$got;$expected=$exp->renderExp unless defined$expected;$message="Compared $where" unless defined$message;$diag=<<EOM}return$diag}sub render_val {my$val=shift;my$rendered;if (defined$val){$rendered=ref($val)? (Scalar::Util::refaddr($val)eq $DNE_ADDR ? "Does not exist" : overload::StrVal($val)): qq('$val')}else {$rendered="undef"}return$rendered}sub descend {my ($d1,$d2)=@_;if (!ref$d1 and!ref$d2){if (defined$d1){return 1 if defined$d2 and $d1 eq $d2}else {return 1 if!defined$d2}}if (!$Expects and Scalar::Util::blessed($d1)and $d1->isa("Test::Deep::Cmp")){my$where=$Stack->render('$data');confess "Found a special comparison in $where\nYou can only use specials in the expects structure"}if (ref$d1 and ref$d2){if ($Expects and Scalar::Util::blessed($d1)and $d1->isa("Test::Deep::Cmp")){return 0 unless Test::Deep::blessed(Scalar::Util::blessed($d2))->descend($d1);if ($d1->can("compare")){return$d1->compare($d2)}}my$s1=Scalar::Util::refaddr($d1);my$s2=Scalar::Util::refaddr($d2);if ($s1 eq $s2){return 1}if ($CompareCache->cmp($d1,$d2)){return 1}else {$CompareCache->add($d1,$d2)}}$d2=wrap($d2);$Stack->push({exp=>$d2,got=>$d1});if (ref($d1)and (Scalar::Util::refaddr($d1)==$DNE_ADDR)){return 0}if ($d2->descend($d1)){$Stack->pop;return 1}else {return 0}}sub wrap {my$data=shift;my$class=Scalar::Util::blessed($data);return$data if defined$class and $data->isa("Test::Deep::Cmp");if (defined$class and $data->can('as_test_deep_cmp')){my$cmp=$data->as_test_deep_cmp;return$cmp if$cmp->isa('Test::Deep::Cmp');Carp::confess("object in expected structure provides as_test_deep_cmp but it did not return a Test::Deep::Cmp")}my$reftype=_td_reftype($data);my$cmp;if($reftype eq ''){$cmp=$Test::Deep::LeafWrapper ? $Test::Deep::LeafWrapper->($data): shallow($data)}else {my$addr=Scalar::Util::refaddr($data);return$WrapCache{$addr}if$WrapCache{$addr};if($reftype eq 'ARRAY'){$cmp=array($data)}elsif($reftype eq 'HASH'){$cmp=hash($data)}elsif($reftype eq 'SCALAR' or $reftype eq 'REF'){$cmp=scalref($data)}elsif(($reftype eq 'Regexp')or ($reftype eq 'REGEXP')){$cmp=regexpref($data)}else {$cmp=$Test::Deep::LeafWrapper ? $Test::Deep::LeafWrapper->($data): shallow($data)}$WrapCache{$addr}=$cmp}return$cmp}sub _td_reftype {my$val=shift;my$reftype=Scalar::Util::reftype($val);return '' unless defined$reftype;return$reftype unless$Test::Deep::RegexpVersion::OldStyle;my$blessed=Scalar::Util::blessed($val);return$reftype unless defined$blessed;if ($blessed && $blessed eq "Regexp" and $reftype eq "SCALAR"){$reftype="Regexp"}return$reftype}sub render_stack {my ($var,$stack)=@_;return$stack->render($var)}sub cmp_methods {local$Test::Builder::Level=$Test::Builder::Level + 1;return cmp_deeply(shift,methods(@{shift()}),shift)}sub requireclass {require Test::Deep::Class;my$val=shift;return Test::Deep::Class->new(1,$val)}*useclass=\&requireclass;sub noclass {require Test::Deep::Class;my$val=shift;return Test::Deep::Class->new(0,$val)}sub set {require Test::Deep::Set;return Test::Deep::Set->new(1,"",@_)}sub supersetof {require Test::Deep::Set;return Test::Deep::Set->new(1,"sup",@_)}sub subsetof {require Test::Deep::Set;return Test::Deep::Set->new(1,"sub",@_)}sub noneof {require Test::Deep::Set;return Test::Deep::Set->new(1,"none",@_)}sub cmp_set {local$Test::Builder::Level=$Test::Builder::Level + 1;return cmp_deeply(shift,set(@{shift()}),shift)}sub bag {require Test::Deep::Set;return Test::Deep::Set->new(0,"",@_)}sub superbagof {require Test::Deep::Set;return Test::Deep::Set->new(0,"sup",@_)}sub subbagof {require Test::Deep::Set;return Test::Deep::Set->new(0,"sub",@_)}sub cmp_bag {local$Test::Builder::Level=$Test::Builder::Level + 1;my$ref=ref($_[1])|| "";confess "Argument 2 to cmp_bag is not an ARRAY ref (".render_val($_[1]).")" unless$ref eq "ARRAY";return cmp_deeply(shift,bag(@{shift()}),shift)}sub superhashof {require Test::Deep::Hash;my$val=shift;return Test::Deep::SuperHash->new($val)}sub subhashof {require Test::Deep::Hash;my$val=shift;return Test::Deep::SubHash->new($val)}sub builder {if (@_){$Test=shift}return$Test}1;
$message
   got : $got
expect : $expected
EOM
