package XML::SAX::Expat;use strict;use base qw(XML::SAX::Base);use XML::NamespaceSupport qw();use XML::Parser qw();use vars qw($VERSION);$VERSION='0.51';sub _parse_characterstream {my$p=shift;my$xml=shift;my$opt=shift;my$expat=$p->_create_parser($opt);my$result=$expat->parse($xml);$p->_cleanup;return$result}sub _parse_bytestream {my$p=shift;my$xml=shift;my$opt=shift;my$expat=$p->_create_parser($opt);my$result=$expat->parse($xml);$p->_cleanup;return$result}sub _parse_string {my$p=shift;my$xml=shift;my$opt=shift;my$expat=$p->_create_parser($opt);my$result=$expat->parse($xml);$p->_cleanup;return$result}sub _parse_systemid {my$p=shift;my$xml=shift;my$opt=shift;my$expat=$p->_create_parser($opt);my$result=$expat->parsefile($xml);$p->_cleanup;return$result}sub _create_parser {my$self=shift;my$opt=shift;die "ParserReference: parser instance ($self) already parsing\n" if$self->{_InParse};my$featUri='http://xml.org/sax/features/';my$ppe=($self->get_feature($featUri .'external-general-entities')or $self->get_feature($featUri .'external-parameter-entities'))? 1 : 0;my$expat=XML::Parser->new(ParseParamEnt=>$ppe);$expat->{__XSE}=$self;$expat->setHandlers(Init=>\&_handle_init,Final=>\&_handle_final,Start=>\&_handle_start,End=>\&_handle_end,Char=>\&_handle_char,Comment=>\&_handle_comment,Proc=>\&_handle_proc,CdataStart=>\&_handle_start_cdata,CdataEnd=>\&_handle_end_cdata,Unparsed=>\&_handle_unparsed_entity,Notation=>\&_handle_notation_decl,Entity=>\&_handle_entity_decl,Element=>\&_handle_element_decl,Attlist=>\&_handle_attr_decl,Doctype=>\&_handle_start_doctype,DoctypeFin=>\&_handle_end_doctype,XMLDecl=>\&_handle_xml_decl,);$self->{_InParse}=1;$self->{_NodeStack}=[];$self->{_NSStack}=[];$self->{_NSHelper}=XML::NamespaceSupport->new({xmlns=>1});$self->{_started}=0;return$expat}sub _cleanup {my$self=shift;$self->{_InParse}=0;delete$self->{_NodeStack}}sub _handle_init {}sub _handle_final {my$self=shift()->{__XSE};return$self->SUPER::end_document({})}sub _handle_start {my$self=shift()->{__XSE};my$e_name=shift;my%attr=@_;$self->_handle_start_document({})unless$self->{_started};my$nsh=$self->{_NSHelper};$nsh->push_context;my@new_ns;for my$k (grep!index($_,'xmlns'),keys%attr){$k =~ m/^xmlns(:(.*))?$/;my$prefix=$2 || '';$nsh->declare_prefix($prefix,$attr{$k});my$ns={Prefix=>$prefix,NamespaceURI=>$attr{$k},};push@new_ns,$ns;$self->SUPER::start_prefix_mapping($ns)}push @{$self->{_NSStack}},\@new_ns;my%saxattr;map {my ($ns,$prefix,$lname)=$nsh->process_attribute_name($_);$saxattr{'{' .($ns || '').'}' .$lname}={Name=>$_,LocalName=>$lname || '',Prefix=>$prefix || '',Value=>$attr{$_},NamespaceURI=>$ns || '',}}keys%attr;my ($ns,$prefix,$lname)=$nsh->process_element_name($e_name);my$element={Name=>$e_name,LocalName=>$lname || '',Prefix=>$prefix || '',NamespaceURI=>$ns || '',Attributes=>\%saxattr,};push @{$self->{_NodeStack}},$element;$self->SUPER::start_element($element)}sub _handle_end {my$self=shift()->{__XSE};my%element=%{pop @{$self->{_NodeStack}}};delete$element{Attributes};$self->SUPER::end_element(\%element);my$prev_ns=pop @{$self->{_NSStack}};for my$ns (@$prev_ns){$self->SUPER::end_prefix_mapping({%$ns })}$self->{_NSHelper}->pop_context}sub _handle_char {$_[0]->{__XSE}->_handle_start_document({})unless $_[0]->{__XSE}->{_started};$_[0]->{__XSE}->SUPER::characters({Data=>$_[1]})}sub _handle_comment {$_[0]->{__XSE}->_handle_start_document({})unless $_[0]->{__XSE}->{_started};$_[0]->{__XSE}->SUPER::comment({Data=>$_[1]})}sub _handle_proc {$_[0]->{__XSE}->_handle_start_document({})unless $_[0]->{__XSE}->{_started};$_[0]->{__XSE}->SUPER::processing_instruction({Target=>$_[1],Data=>$_[2]})}sub _handle_start_cdata {$_[0]->{__XSE}->SUPER::start_cdata({})}sub _handle_end_cdata {$_[0]->{__XSE}->SUPER::end_cdata({})}sub _handle_xml_decl {my$self=shift()->{__XSE};my$version=shift;my$encoding=shift;my$standalone=shift;if (not defined$standalone){$standalone=''}elsif ($standalone){$standalone='yes'}else {$standalone='no'}my$xd={Version=>$version,Encoding=>$encoding,Standalone=>$standalone,};$self->_handle_start_document($xd)}sub _handle_notation_decl {my$self=shift()->{__XSE};my$notation=shift;shift;my$system=shift;my$public=shift;my$not={Name=>$notation,PublicId=>$public,SystemId=>$system,};$self->SUPER::notation_decl($not)}sub _handle_unparsed_entity {my$self=shift()->{__XSE};my$name=shift;my$system=shift;my$public=shift;my$notation=shift;my$ue={Name=>$name,PublicId=>$public,SystemId=>$system,Notation=>$notation,};$self->SUPER::unparsed_entity_decl($ue)}sub _handle_element_decl {$_[0]->{__XSE}->SUPER::element_decl({Name=>$_[1],Model=>"$_[2]" })}sub _handle_attr_decl {my$self=shift()->{__XSE};my$ename=shift;my$aname=shift;my$type=shift;my$default=shift;my$fixed=shift;my ($vd,$value);if ($fixed){$vd='#FIXED';$default =~ s/^(?:"|')//;$default =~ s/(?:"|')$//;$value=$default}else {if ($default =~ m/^#/){$vd=$default;$value=''}else {$vd='';$default =~ s/^(?:"|')//;$default =~ s/(?:"|')$//;$value=$default}}my$at={eName=>$ename,aName=>$aname,Type=>$type,ValueDefault=>$vd,Value=>$value,};$self->SUPER::attribute_decl($at)}sub _handle_entity_decl {my$self=shift()->{__XSE};my$name=shift;my$val=shift;my$sys=shift;my$pub=shift;my$ndata=shift;my$isprm=shift;if ($isprm){$name='%' .$name}if ($val){my$ent={Name=>$name,Value=>$val,};$self->SUPER::internal_entity_decl($ent)}else {my$ent={Name=>$name,PublicId=>$pub || '',SystemId=>$sys,};$self->SUPER::external_entity_decl($ent)}}sub _handle_start_doctype {my$self=shift()->{__XSE};my$name=shift;my$sys=shift;my$pub=shift;$self->_handle_start_document({})unless$self->{_started};my$dtd={Name=>$name,SystemId=>$sys,PublicId=>$pub,};$self->SUPER::start_dtd($dtd)}sub _handle_end_doctype {$_[0]->{__XSE}->SUPER::end_dtd({})}sub _handle_start_document {$_[0]->SUPER::start_document($_[1]);$_[0]->{_started}=1}sub supported_features {return ($_[0]->SUPER::supported_features,'http://xml.org/sax/features/external-general-entities','http://xml.org/sax/features/external-parameter-entities',)}1;