package XML::SAX::ParserFactory;use strict;use vars qw($VERSION);$VERSION='1.02';use Symbol qw(gensym);use XML::SAX;use XML::SAX::Exception;sub new {my$class=shift;my%params=@_;my$self=bless \%params,$class;$self->{KnownParsers}=XML::SAX->parsers();return$self}sub parser {my$self=shift;my@parser_params=@_;if (!ref($self)){$self=$self->new()}my$parser_class=$self->_parser_class();my$version='';if ($parser_class =~ s/\s*\(([\d\.]+)\)\s*$//){$version=" $1"}if (!$parser_class->can('new')){eval "require $parser_class $version;";die $@ if $@}return$parser_class->new(@parser_params)}sub require_feature {my$self=shift;my ($feature)=@_;$self->{RequiredFeatures}{$feature}++;return$self}sub _parser_class {my$self=shift;if ($XML::SAX::ParserPackage){return$XML::SAX::ParserPackage}if ($self->{RequiredFeatures}){my%required=%{$self->{RequiredFeatures}};PARSER: foreach my$parser (reverse @{$self->{KnownParsers}}){for my$feature (keys%required){if (!exists$parser->{Features}{$feature}){next PARSER}}return$parser->{Name}}throw XML::SAX::Exception (Message=>"Unable to provide required features",)}for my$dir (@INC){my$fh=gensym();if (open($fh,"$dir/SAX.ini")){my$param_list=XML::SAX->_parse_ini_file($fh);my$params=$param_list->[0]->{Features};if ($params->{ParserPackage}){return$params->{ParserPackage}}else {PARSER: foreach my$parser (reverse @{$self->{KnownParsers}}){for my$feature (keys %$params){if (!exists$parser->{Features}{$feature}){next PARSER}}return$parser->{Name}}XML::SAX->do_warn("Unable to provide SAX.ini required features. Using fallback\n")}last}}if (@{$self->{KnownParsers}}){return$self->{KnownParsers}[-1]{Name}}else {return "XML::SAX::PurePerl"}}1;